<?php
 require_once($GLOBALS['sLibDir'] . "class.Log.php"); require_once($GLOBALS['sLibDir'] . "class.Util.php"); require_once($GLOBALS['sLibDir'] . "class.GnAccess.php"); require_once('HTTP/Request2.php'); class GnXs { const S_NS_CSW = 'http://www.opengis.net/cat/csw/2.0.2'; const S_NS_GMD = 'http://www.isotc211.org/2005/gmd'; const S_NS_GC = 'http://purl.org/dc/elements/1.1'; const S_NS_GCT = 'http://purl.org/dc/terms'; const S_NS_GEONET = 'http://www.fao.org/geonetwork'; private $oGnAccess; private $sXsUrl = null; private $iMaxRetry = 0; function __construct(GnAccess $oGnAccess) { $this->oGnAccess = $oGnAccess; $sGnUrl = $this->oGnAccess->getGnUrl(); $this->sXsUrl = $sGnUrl . "/srv/en/"; } public function importMef($sMefPath) { $oLog = Log::getObj(); $aId = array(); $iRetry = 0; $bShowRawXml = false; $aLoginAck = $this->oGnAccess->login(); if ($aLoginAck['bOk']) { $oReq = new HTTP_Request2($this->sXsUrl . 'mef.import'); $oReq->setMethod(HTTP_Request2::METHOD_POST) ->addUpload('mefFile', $sMefPath, $sMefPath, 'application/zip'); if (!is_null($aLoginAck['sSesId'])) { $oReq->addCookie('JSESSIONID', $aLoginAck['sSesId']); } $bOk = false; while (!$bOk) { $aImportAck = $this->oGnAccess->sendReq($oReq); if ($aImportAck['bOk']) { $bOk = true; $oRespDom = new DOMDocument(); $oRespDom->loadXML($aImportAck['sResp']); $oIdEle = $oRespDom->getElementsByTagName('id'); if ($oIdEle && $oIdEle->item(0)) { $aId = preg_split("/;/", preg_replace('/;\s*$/', '', $oIdEle->item(0)->nodeValue)); if ($bShowRawXml) { print("<p>Raw data:</p>"); $this->oGnAccess->htmlGnResp($aImportAck['sResp']); } } else { trigger_error("<p>Unexpected response from GeoNetwork:</p>" . $this->oGnAccess->htmlGnResp($aImportAck['sResp']), E_USER_ERROR); } } else { if (($aImportAck['iStatus'] == 500) && ($iRetry++ < $this->iMaxRetry)) { sleep(5); } else { $sMsg1 = "Error during import: {$aImportAck['sResp']}"; $oLog->genLine($sMsg1); $sMsg2 = (($aImportAck['iStatus'] == 400) ? "Please look into GeoNetwork's log file (found inside Tomcat's " . "installation directory as \"logs/geonetwork.log\") to see if the " . "amount of data to upload has exceeded the limit set by " . "\"maxUploadSize\" (in webapps/geonetwork/WEB-INF/config.xml)." : null); if (!is_null($sMsg2)) { $oLog->genLine($sMsg2); } throw new Exception("$sMsg1 $sMsg2"); } } } } else { throw new Exception("Fail to authenticate ({$aLoginAck['sResp']})"); } return array($aId, $iRetry); } public function updMetadata($sId, $iVer, $sXml) { $iCurVer = $iVer; $aLoginAck = $this->oGnAccess->login(); if ($aLoginAck['bOk']) { $oReq = new HTTP_Request2($this->sXsUrl . 'metadata.update.finish'); $bOk = false; while (!$bOk) { $oReq->setMethod(HTTP_Request2::METHOD_POST) ->setHeader('Content-type: text/xml; charset=utf-8') ->setBody("<?xml version='1.0'?" . ">" . "<request>
                                 <id>$sId</id>
                                 <version>$iCurVer</version>
                                 <data><![CDATA[
                                   $sXml
                                   ]]>
                                 </data>
                               </request>"); if (!is_null($aLoginAck['sSesId'])) { $oReq->addCookie('JSESSIONID', $aLoginAck['sSesId']); } $aReqAck = $this->oGnAccess->sendReq($oReq); if ($aReqAck['bOk']) { $bOk = true; } elseif ($aReqAck['iStatus'] == 400) { $iCurVer++; } else { throw new Exception("<p>
                                           Error from the server:
                                         </p>
                                         <pre>{$aReqAck['sResp']}</pre>"); } } } else { throw new Exception("Fail to authenticate ({$aLoginAck['sResp']})"); } return $iCurVer; } public function getHarvestInfo() { $aLoginAck = $this->oGnAccess->login(); if ($aLoginAck['bOk']) { $oReq = new HTTP_Request2($this->sXsUrl . 'xml.harvesting.get'); $oReq->setMethod(HTTP_Request2::METHOD_POST) ->setHeader('Content-type: text/xml; charset=utf-8') ->setBody("<?xml version='1.0'?" . ">" . "<request>
                           </request>"); if (!is_null($aLoginAck['sSesId'])) { $oReq->addCookie('JSESSIONID', $aLoginAck['sSesId']); } $aReqAck = $this->oGnAccess->sendReq($oReq); if ($aReqAck['bOk']) { $oRespDom = new DOMDocument(); print("<pre>" . htmlentities($aReqAck['sResp']) . "</pre>"); } else { throw new Exception("<p>
                                       Error from the server:
                                     </p>
                                     <pre>{$aReqAck['sResp']}</pre>"); } } else { throw new Exception("Fail to authenticate ({$aLoginAck['sResp']})"); } return; } public function getGnSiteInfo() { $aSiteInfo = array('sSiteId' => null, 'sSiteName' => null); $aLoginAck = $this->oGnAccess->login(); if ($aLoginAck['bOk']) { $oReq = new HTTP_Request2($this->sXsUrl . 'xml.info'); $oReq->setMethod(HTTP_Request2::METHOD_POST) ->setHeader('Content-type: text/xml; charset=utf-8') ->setBody("<?xml version='1.0'?" . ">" . "<request>
                             <type>site</type>
                           </request>"); if (!is_null($aLoginAck['sSesId'])) { $oReq->addCookie('JSESSIONID', $aLoginAck['sSesId']); } $aReqAck = $this->oGnAccess->sendReq($oReq); if ($aReqAck['bOk']) { $oRespDom = new DOMDocument(); $oRespDom->loadXML($aReqAck['sResp']); $aSiteInfo['sSiteId'] = Util::getDomNode($oRespDom, array('info', 'site', 'siteId'))->nodeValue; $aSiteInfo['sSiteName'] = Util::getDomNode($oRespDom, array('info', 'site', 'name'))->nodeValue; } else { throw new Exception("<p>
                                       Error from the server:
                                     </p>
                                     <pre>{$aReqAck['sResp']}</pre>"); } } else { throw new Exception("Fail to authenticate ({$aLoginAck['sResp']})"); } return $aSiteInfo; } public function getGnSiteName() { $sSiteName = null; $aLoginAck = $this->oGnAccess->login(); if ($aLoginAck['bOk']) { $oReq = new HTTP_Request2($this->sXsUrl . 'xml.config.get'); $oReq->setMethod(HTTP_Request2::METHOD_GET); if (!is_null($aLoginAck['sSesId'])) { $oReq->addCookie('JSESSIONID', $aLoginAck['sSesId']); } $aReqAck = $this->oGnAccess->sendReq($oReq); if ($aReqAck['bOk']) { $oRespDom = new DOMDocument(); $oRespDom->loadXML($aReqAck['sResp']); $sSiteName = Util::getDomNode($oRespDom, array('config', 'site', 'name'))->nodeValue; } else { throw new Exception("<p>
                                       Error from the server:
                                     </p>
                                     <pre>{$aReqAck['sResp']}</pre>"); } } else { throw new Exception("Fail to authenticate ({$aLoginAck['sResp']})"); } return $sSiteName; } public function setMdGrpPriv($sMdId, $aGrpPriv=null) { $aLoginAck = $this->oGnAccess->login(); if ($aLoginAck['bOk']) { $oReq = new HTTP_Request2($this->sXsUrl . 'metadata.admin'); $oReq->setMethod(HTTP_Request2::METHOD_POST) ->setHeader('Content-type: text/xml; charset=utf-8') ->setBody("<?xml version='1.0'?" . ">" . "<request>
                              <id>$sMdId</id>
                              <_3_0 />
                            </request>"); if (!is_null($aLoginAck['sSesId'])) { $oReq->addCookie('JSESSIONID', $aLoginAck['sSesId']); } $aReqAck = $this->oGnAccess->sendReq($oReq); if ($aReqAck['bOk']) { $oRespDom = new DOMDocument(); $oRespDom->loadXML($aReqAck['sResp']); $sResId = Util::getDomNodeVal($oRespDom, array('response', 'id')); if (is_null($sResId)) { $sMsg = "<p>
                               Failed to set the group privilege for the record id \"$sMdId\".
                             </p>
                             <pre>" . $aReqAck['sResp'] . "</pre>"; Log::getObj()->genLine($sMsg, Log::I_DETAIL); throw new Exception($sMsg); } } else { $sMsg = "<p>
                           Error from the server:
                         </p>
                         <pre>{$aReqAck['sResp']}</pre>"; Log::getObj()->genLine($sMsg, Log::I_DETAIL); throw new Exception($sMsg); } } else { throw new Exception("Fail to authenticate ({$aLoginAck['sResp']})"); } } public function getMmbrGrp($sUserId) { $aMmbrGrp = array(); $aLoginAck = $this->oGnAccess->login(); if ($aLoginAck['bOk']) { $oReq = new HTTP_Request2($this->sXsUrl . 'xml.usergroups.list'); $oReq->setMethod(HTTP_Request2::METHOD_POST) ->setHeader('Content-type: text/xml; charset=utf-8') ->setBody("<?xml version='1.0'?" . ">" . "<request><id>$sUserId</id></request>"); if (!is_null($aLoginAck['sSesId'])) { $oReq->addCookie('JSESSIONID', $aLoginAck['sSesId']); } $aReqAck = $this->oGnAccess->sendReq($oReq); if ($aReqAck['bOk']) { $oRespDom = new DOMDocument(); $oRespDom->loadXML($aReqAck['sResp']); $aRecNode = Util::getDomNodeList($oRespDom, array('groups', 'group')); if (count($aRecNode) > 0) { foreach ($aRecNode as $oRecNode) { $aMmbrGrp[] = array('id' => Util::getDomNodeVal($oRecNode, array('id'))); } } } else { $sMsg = "<p>
                           The current GeoNetwork user must have at least the profile \"user administrator\".
                         </p>
                         <p>
                           Error from the server:
                         </p>
                         <pre>{$aReqAck['sResp']}</pre>"; Log::getObj()->genLine($sMsg, Log::I_DETAIL); throw new Exception($sMsg); } } else { throw new Exception("Fail to authenticate ({$aLoginAck['sResp']})"); } if (count($aMmbrGrp) == 0) { throw new Exception("Fail to locate any member group for the user id - \"$sUserId\"."); } return $aMmbrGrp; } public function cnvUsernameToId($sUsername) { $sUserId = null; $aLoginAck = $this->oGnAccess->login(); if ($aLoginAck['bOk']) { $oReq = new HTTP_Request2($this->sXsUrl . 'xml.user.list'); $oReq->setMethod(HTTP_Request2::METHOD_POST) ->setHeader('Content-type: text/xml; charset=utf-8') ->setBody("<?xml version='1.0'?" . ">" . "<request />"); if (!is_null($aLoginAck['sSesId'])) { $oReq->addCookie('JSESSIONID', $aLoginAck['sSesId']); } $aReqAck = $this->oGnAccess->sendReq($oReq); if ($aReqAck['bOk']) { $oRespDom = new DOMDocument(); $oRespDom->loadXML($aReqAck['sResp']); $aRecNode = Util::getDomNodeList($oRespDom, array('response', 'record')); if (count($aRecNode) > 0) { foreach ($aRecNode as $oRecNode) { if (Util::getDomNodeVal($oRecNode, array('username')) == $sUsername) { $sUserId = Util::getDomNodeVal($oRecNode, array('id')); break; } } } } else { $sMsg = "<p>
                           Error from the server:
                         </p>
                         <pre>{$aReqAck['sResp']}</pre>"; Log::getObj()->genLine($sMsg, Log::I_DETAIL); throw new Exception($sMsg); } } else { throw new Exception("Fail to authenticate ({$aLoginAck['sResp']})"); } if (is_null($sUserId)) { throw new Exception("Fail to locate the username - \"$sUsername\"."); } return $sUserId; } public function cnvUuidToId($sUuid) { $aLoginAck = $this->oGnAccess->login(); if ($aLoginAck['bOk']) { $oReq = new HTTP_Request2($this->sXsUrl . 'xml.metadata.get'); $oReq->setMethod(HTTP_Request2::METHOD_POST) ->setHeader('Content-type: text/xml; charset=utf-8') ->setBody("<?xml version='1.0'?" . ">" . "<request>
                              <uuid>$sUuid</uuid>
                            </request>"); if (!is_null($aLoginAck['sSesId'])) { $oReq->addCookie('JSESSIONID', $aLoginAck['sSesId']); } $aReqAck = $this->oGnAccess->sendReq($oReq); if ($aReqAck['bOk']) { $oRespDom = new DOMDocument(); $oRespDom->loadXML($aReqAck['sResp']); $sId = Util::getDomNodeVal($oRespDom, array(self::S_NS_GMD . '/MD_Metadata', self::S_NS_GEONET . '/info', 'id')); if (is_null($sId)) { $sMsg = "<p>
                               Failed to locate the ID field in the metadata record for \"{$sUuid}\".
                             </p>
                             <p>
                               Please check GeoNetwork's config.xml to ensure that \"skipInfo\" is set to \"n\" for the service \"xml.metadata.get\".
                             </p>
                             <pre>" . $aReqAck['sResp'] . "</pre>"; Log::getObj()->genLine($sMsg, Log::I_DETAIL); throw new Exception($sMsg); } } else { $sMsg = "<p>
                           Error from the server:
                         </p>
                         <pre>{$aReqAck['sResp']}</pre>"; Log::getObj()->genLine($sMsg, Log::I_DETAIL); throw new Exception($sMsg); } } else { throw new Exception("Fail to authenticate ({$aLoginAck['sResp']})"); } return $sId; } public function getMdOwner($sMdUuid) { $sOwnerName = null; $aLoginAck = $this->oGnAccess->login(); if ($aLoginAck['bOk']) { $oReq = new HTTP_Request2($this->sXsUrl . 'xml.metadata.get'); $oReq->setMethod(HTTP_Request2::METHOD_POST) ->setHeader('Content-type: text/xml; charset=utf-8') ->setBody("<?xml version='1.0'?" . ">" . "<request>
                              <uuid>$sMdUuid</uuid>
                            </request>"); if (!is_null($aLoginAck['sSesId'])) { $oReq->addCookie('JSESSIONID', $aLoginAck['sSesId']); } $aReqAck = $this->oGnAccess->sendReq($oReq); if ($aReqAck['bOk']) { $oRespDom = new DOMDocument(); $oRespDom->loadXML($aReqAck['sResp']); $sOwnerName = Util::getDomNodeVal($oRespDom, array(self::S_NS_GMD . '/MD_Metadata', self::S_NS_GEONET . '/info', 'ownername')); if (is_null($sOwnerName)) { $sMsg = "<p>
                               Failed to identify the owner of the metadata record \"{$sMdUuid}\".
                             </p>
                             <p>
                               Please check GeoNetwork's config.xml to ensure that \"skipInfo\" is set to \"n\" for the service \"xml.metadata.get\".
                             </p>
                             <pre>" . $aReqAck['sResp'] . "</pre>"; Log::getObj()->genLine($sMsg, Log::I_DETAIL); throw new Exception($sMsg); } } else { $sMsg = "<p>
                           Error from the server:
                         </p>
                         <pre>{$aReqAck['sResp']}</pre>"; Log::getObj()->genLine($sMsg, Log::I_DETAIL); throw new Exception($sMsg); } } else { throw new Exception("Fail to authenticate ({$aLoginAck['sResp']})"); } return $sOwnerName; } } ?>
