<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                version="1.0"
                xmlns:xs="http://www.w3.org/2001/XMLSchema"
                xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
                xmlns:xlink="http://www.w3.org/1999/xlink"
                xmlns:gco="http://www.isotc211.org/2005/gco"
                xmlns:gmd="http://www.isotc211.org/2005/gmd"
                xmlns:grg="http://www.isotc211.org/2005/grg"
                xsi:schemaLocation="http://www.isotc211.org/2005/grg ../grg/grg.xsd"
                xmlns:php="http://php.net/xsl">
<!--
xmlns:grg="http://www.cits.rncan.gc.ca/html/brodeurj/.protege/.napMetadata/xsd/grg"
xsi:schemaLocation="http://www.cits.rncan.gc.ca/html/brodeurj/.protege/.napMetadata/xsd/grg ../grg/grg.xsd"
                xmlns:gco="http://www.isotc211.org/schemas/2005/gco"
                xmlns:gmd="http://www.isotc211.org/schemas/2005/gmd"
-->
    <xsl:key name="aItemDef" match="grg:RE_RegisterItem" use="@id"/>

    <xsl:template match="grg:RE_Register">
        <xsl:apply-templates select="grg:containedItemClass/grg:RE_ItemClass"/>
    </xsl:template>

    <xsl:template match="grg:RE_ItemClass">
        <!--BL*20120203 <xsl:if test="substring(grg:name/gco:CharacterString, 1, 3) = 'nap'">-->
            <xsl:apply-templates select="grg:describedItem">
                <xsl:with-param name="sClassId" select="@id"/>
                <xsl:with-param name="sClassName"
                                select="normalize-space(grg:name/gco:CharacterString)"/>
            </xsl:apply-templates>
        <!--BL*20120203 </xsl:if>-->
    </xsl:template>

    <xsl:template match="grg:describedItem">
        <xsl:param name="sClassId" required="yes"/>
        <xsl:param name="sClassName" required="yes"/>
        <xsl:variable name="sItemId" select="substring-after(@xlink:href, '#')"/>
        <xsl:variable name="eItemDef" select="key('aItemDef',$sItemId)"/>
        <xsl:value-of
             select="php:functionString('Reg::addClassItem', $sClassId, $sClassName, $sItemId, normalize-space($eItemDef/grg:name), normalize-space($eItemDef/grg:definition), normalize-space($eItemDef/grg:description), normalize-space($eItemDef/grg:alternativeExpressions/grg:RE_AlternativeExpression/grg:name), normalize-space($eItemDef/grg:alternativeExpressions/grg:RE_AlternativeExpression/grg:definition), normalize-space($eItemDef/grg:alternativeExpressions/grg:RE_AlternativeExpression/grg:description))" />
        <!--
        <xsl:value-of
             select="php:functionString('Reg::addClassItem', $sClassId, $sClassName, $sItemId, normalize-space($eItemDef/grg:name))" />
        -->
    </xsl:template>

</xsl:stylesheet>
