<?xml version='1.0' ?>
<!--
Modifications:

BL*instrmnt Add output for instrumentation purpose.

BL*addSchema Add to every generated schema element a namespace the
             same as that of the links element. Without this addition,
             xs3p.xsl may fail to locate the proper schema element.

BL*ignoreNetworkSchema Ignore network schema reference for we do not
                       know how to generate the documentation file for
                       such schema.
-->
<xsl:stylesheet
        version="1.0"
        xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
        xmlns:xs="http://www.w3.org/2001/XMLSchema"
        exclude-result-prefixes="xs">

        <xsl:output
                method="xml"
                indent="yes"/>
        <xsl:param name="recursive">false</xsl:param>
        <xsl:param name="xsdFileSpec"></xsl:param>
        <xsl:template match="/">
                <links xmlns="http://titanium.dstc.edu.au/xml/xs3p">
                        <xsl:apply-templates select="//xs:include | //xs:import" />
                </links>
        </xsl:template>

        <xsl:template match="xs:include | xs:import">

           <!--BL*ignoreNetworkSchema*20120103+ -->
           <!--<xsl:if test="not(contains(@schemaLocation, 'http://'))">-->
           <!--BL*ignoreNetworkSchema*20120103- -->
                <schema>
                        <!--BL*addSchema*20111230+ -->
                        <xsl:attribute name="xmlns">
                           <xsl:text>http://titanium.dstc.edu.au/xml/xs3p</xsl:text>
                        </xsl:attribute>
                        <!--BL*addSchema*20111230- -->

                        <!--BL*instrmnt*20111230+ When trying to find out
                        - which file had caused a particular schema
                        - element, enable the following attribute.
                        -->
                        <!--
                        <xsl:attribute name="ref-file-spec">
                            <xsl:value-of select="$xsdFileSpec"/>
                        </xsl:attribute>
                        -->
                        <!--BL*instrmnt*20111230- -->

                        <xsl:attribute name="file-location">
                                <xsl:value-of select="@schemaLocation"/>
                        </xsl:attribute>
                        <xsl:attribute name="docfile-location">
                                <xsl:value-of select="@schemaLocation"/>.html</xsl:attribute>
                </schema>
           <!--BL*ignoreNetworkSchema*20120103+ -->
           <!--</xsl:if>-->
           <!--BL*ignoreNetworkSchema*20120103- -->

                <xsl:if test="normalize-space(translate($recursive, 'TRUE', 'true'))='true'">
                       <xsl:apply-templates select="document(@schemaLocation)/xs:schema/xs:include | document(@schemaLocation)/xs:schema/xs:import" />
                </xsl:if>
        </xsl:template>

</xsl:stylesheet>
