<?php
 require_once($GLOBALS['sLibDir'] . "class.Util.php"); require_once($GLOBALS['sLibDir'] . "class.BrowserMsg.php"); class Dbms{ const S_ORCL = "Oracle"; const S_PSQL = "PostgreSQL"; const S_SQL_SERVER = "Microsoft_SQL_Server"; protected $aValidDbmsId = null; protected $iDbRefCount = 1; protected $aSqlAlias = array(); protected $aTblAlias = array(); protected $bIsOracle = false; public function __construct() { $this->aValidDbmsId = array(self::S_ORCL, self::S_PSQL, self::S_SQL_SERVER); } public function getTblCol($aConnectDef) { $aTblCol = array(); $aErrMsg = array(); foreach ($aConnectDef as $sName => $sVal) { if (trim($sVal) == "") { $aErrMsg[] = "\"$sName\" must be filled in."; } } if (count($aErrMsg) == 0) { $sDbmsId = $aConnectDef['sDbmsId']; if ($this->isValidDbmsId($sDbmsId)) { require_once($GLOBALS['sLibDir'] . "class.{$sDbmsId}.php"); $oDb = new $sDbmsId($this->makeObjInitParam($sDbmsId, $aConnectDef)); $aTblCol = $this->listTblCol($oDb, $this->makeTblColSql($sDbmsId, $aConnectDef)); } else { trigger_error("Unrecognized DBMS - $sDbmsId." . print_r($aConnectDef, true), E_USER_ERROR); } } else { trigger_error(join("\n", $aErrMsg), E_USER_ERROR); } return $aTblCol; } public function testConnect($aConnectDef) { $aErrMsg = array(); foreach ($aConnectDef as $sName => $sVal) { if (trim($sVal) == "") { $aErrMsg[] = "\"$sName\" must be filled in."; } } if (count($aErrMsg) == 0) { $sDbmsId = $aConnectDef['sDbmsId']; if ($this->isValidDbmsId($sDbmsId)) { require_once($GLOBALS['sLibDir'] . "class.{$sDbmsId}.php"); $oDb = new $sDbmsId($this->makeObjInitParam($sDbmsId, $aConnectDef)); $sErrMsg = $this->checkTblCol($oDb, $this->makeMaxColTblSql($sDbmsId, $aConnectDef)); if (!is_null($sErrMsg)) { trigger_error($sErrMsg, E_USER_ERROR); } } else { trigger_error("Unrecognized DBMS - $sDbmsId." . print_r($aConnectDef, true), E_USER_ERROR); } } else { trigger_error(join("\n", $aErrMsg), E_USER_ERROR); } return; } public function makeRecSql($oCllctnInfo, $aDbRef=null) { $aSel = array(); $aWhere = array(); $sDbmsId = $oCllctnInfo->getDbmsId(); $aGrpMmbr = array(); $this->bIsOracle = ($sDbmsId == self::S_ORCL); $this->aSqlAlias = array(); $sPrimTbl = $oCllctnInfo->getPrimTbl(); $this->aTblAlias = array( $sPrimTbl => 't0'); $aTblPrimCol = $oCllctnInfo->getAllTblPrimCol(); $aTblPathTblColPair = $oCllctnInfo->getAllTblPathTblColPair(); foreach ($aTblPathTblColPair as $sTailTbl => $aPathTblColPair) { $aWhereTail = array(); for ($i=0; $i<count($aPathTblColPair); $i++) { $sFromTbl = $aPathTblColPair[$i]['sTbl']; $sFromCol = $aPathTblColPair[$i]['sCol']; if (!array_key_exists($sFromTbl, $this->aTblAlias)) { $this->aTblAlias[$sFromTbl] = 't' . count($this->aTblAlias); } $sToTbl = (($i == (count($aPathTblColPair) - 1)) ? $sTailTbl : $aPathTblColPair[($i+1)]['sTbl']); if (!array_key_exists($sToTbl, $this->aTblAlias)) { $this->aTblAlias[$sToTbl] = 't' . count($this->aTblAlias); } $sToCol = $aTblPrimCol[$sToTbl]; $aWhereTail[] = "{$this->aTblAlias[$sFromTbl]}.{$sFromCol} = " . "{$this->aTblAlias[$sToTbl]}.{$sToCol}"; } $aWhere[$sTailTbl] = "(" . join(" and \n\t\t", $aWhereTail) . ")"; } $sWhere = join(" and\n\t", array_values($aWhere)); $sFrom = join(",\n\t", array_map(create_function('$sKey, $sVal', 'return "$sKey $sVal";'), array_keys($this->aTblAlias), array_values($this->aTblAlias))); $sSel = null; if (!is_null($aDbRef)) { $aGrpMmbr[] = "{$this->aTblAlias[$sPrimTbl]}.{$aTblPrimCol[$sPrimTbl]}"; foreach ($aDbRef as $aRefField) { $sTblCol = (($aRefField['sTbl'] == '{no table reference}') ? null : $this->aTblAlias[$aRefField['sTbl']] . "." . $aRefField['sCol']); if ($aRefField['sSql'] == '') { $sAlias = $this->aTblAlias[$aRefField['sTbl']] . "_" . $aRefField['sCol']; } else { if (!array_key_exists($aRefField['sSqlId'], $this->aSqlAlias)) { $this->aSqlAlias[$aRefField['sSqlId']] = "s_" . count($this->aSqlAlias); } $sAlias = $this->aSqlAlias[$aRefField['sSqlId']]; } $aSel[] = (($aRefField['sSql'] == '') ? (is_null($sTblCol) ? null : $sTblCol . " as $sAlias") : (is_null($sTblCol) ? $aRefField['sSql'] : preg_replace("/`/", $sTblCol, $aRefField['sSql'])) . " as $sAlias"); if ( !is_null($sTblCol) && !in_array($sTblCol, $aGrpMmbr)) { $aGrpMmbr[] = $sTblCol; } } $sSel = join(", \n\t", $aSel); } $sFromWhere = " from  \n\t$sFrom \n" . (($sWhere == '') ? '' : " where \n\t$sWhere"); return array( "select count(*)" . ((count($aGrpMmbr) > 0) ? ", " . join(", ", array_map(create_function('$iIdx, $sColRef', 'return "count(distinct(' . '$sColRef' . ')' . ') ' . 'as count_$iIdx";'), array_keys($aGrpMmbr), array_values($aGrpMmbr))) . " " : " ") . "\n" . $sFromWhere . "\ngroup by \n\t{$this->aTblAlias[$sPrimTbl]}.{$aTblPrimCol[$sPrimTbl]}", (is_null($sSel) ? "" : "select \n\t$sSel \n" . $sFromWhere . ((count($aGrpMmbr) > 0) ? "\ngroup by \n\t" . join(", \n\t", $aGrpMmbr) : "") . (($sDbmsId == self::S_PSQL) ? " \n" . "order by 1" : ""))); } public function getAlias($aRefField) { $sAlias = (($aRefField['sSql'] == '') ? $this->aTblAlias[$aRefField['sTbl']] . "_" . $aRefField['sCol'] : (array_key_exists($aRefField['sSqlId'], $this->aSqlAlias) ? $this->aSqlAlias[$aRefField['sSqlId']] : null)); return ($this->bIsOracle ? strtoupper($sAlias) : $sAlias); } public function makeSelOneSql($sDbmsId, $sRecSetSql, $iRowNbr) { $sSql = null; switch ($sDbmsId) { case self::S_ORCL: $sSql = "select * \n" . "from (\n" . "\t select x.*, rownum i_row_nbr \n" . "\t from (\n" . $sRecSetSql. "\n" . ") x \n" . "\t where " . "rownum <= $iRowNbr) \n" . "where i_row_nbr = $iRowNbr"; break; case self::S_PSQL: $sSql = $sRecSetSql . "\n" . "offset " . ($iRowNbr - 1) . "\n" . "limit 1"; break; case self::S_SQL_SERVER: $sSql = "select * \n" . "from (\n" . "\t select x.*, " . "row_number() " . "over(" . "order by (" . "select 0)) as i_row_nbr \n" . "\t from (\n" . $sRecSetSql. "\n" . ") x \n" . ") y \n" . "where y.i_row_nbr = $iRowNbr"; break; } return $sSql; } public function prepareDb($aConnectDef, $sCountSql, $sRecSql) { $oDb = $this->connectDb($aConnectDef); if (!is_null($sCountSql)) { list($iRecCount, $iDupCount) = $this->countGrpBy($oDb, $oDb->execSql($sCountSql)); } else { $iRecCount = null; $iDupCount = null; } $oRecSql = (($iRecCount > 0) ? $oDb->execSql($sRecSql) : null); return array($oDb, $iRecCount, $iDupCount, $oRecSql); } public function connectDb($aConnectDef) { $sDbmsId = $aConnectDef['sDbmsId']; require_once($GLOBALS['sLibDir'] . "class.{$sDbmsId}.php"); return new $sDbmsId($this->makeObjInitParam($sDbmsId, $aConnectDef)); } public function countGrpBy($oDb, $oRes) { $iRecCount = 0; $iRepeatCount = 0; if ($oRes) { while ($aCol = $oDb->getRec($oRes)) { $iRecCount++; if (array_shift($aCol) > 1) { while ($iValCount = array_shift($aCol)) { if ($iValCount > 1) { $iRepeatCount++; break; } } } } } else { throw new Exception('Invalid database resource handle.'); } return array($iRecCount, $iRepeatCount); } protected function checkTblCol($oDb, $sSql) { $oSql = $oDb->execSql($sSql); $iColCount = (($aCol = $oDb->getRec($oSql)) ? $aCol['COL_COUNT'] : null); return (is_null($iColCount) ? "The database has no table. Must have at least one table." : (($iColCount == 0) ? "The database does not have a table with column. " . "Must have a table with at least one column." : null)); } protected function isValidDbmsId($sDbmsId) { return in_array($sDbmsId, $this->aValidDbmsId); } protected function makeObjInitParam($sDbmsId, $aConnectDef) { $aParam = array(); switch ($sDbmsId) { case self::S_ORCL: $aParam = array('sUser' => $aConnectDef["User Name"], 'sPassword' => $aConnectDef["User Password"], 'sConnectStr' => "(description =
                                                    (address_list =
                                                      (address =
                                                        (protocol = tcp)
                                                        (host = {$aConnectDef['Server Host']})
                                                        (port = {$aConnectDef['Server Port']})))
                                                    (connect_data =
                                                      (service_name = {$aConnectDef['Service Name']})))"); break; case self::S_PSQL: $aParam = array('sHost' => $aConnectDef['Server Host'], 'iPort' => $aConnectDef['Server Port'], 'sUser' => $aConnectDef['User Name'], 'sPassword' => $aConnectDef['User Password'], 'sDb' => $aConnectDef['Database Name']); break; case self::S_SQL_SERVER: $aParam = array('sHost' => $aConnectDef['Server Host'], 'sInstance' => $aConnectDef['Server Instance'], 'sUser' => $aConnectDef['User Name'], 'sPassword' => $aConnectDef['User Password'], 'sDb' => $aConnectDef['Database Name']); break; } return $aParam; } protected function makeTblColSql($sDbmsId, $aConnectDef) { $sSql = null; switch ($sDbmsId) { case self::S_ORCL: $sSql = "select table_name, column_name
                         from all_tab_columns
                         where owner = '" . strtoupper($aConnectDef['User Name']) . "'
                         order by 1, 2"; break; case self::S_PSQL: $sSql = "select table_name as \"TABLE_NAME\", column_name as \"COLUMN_NAME\"
                         from information_schema.columns
                         where table_schema = 'public'
                         order by 1, 2"; break; case self::S_SQL_SERVER: $sSql = "select table_name as \"TABLE_NAME\", column_name as \"COLUMN_NAME\"
                         from information_schema.columns
                         order by 1, 2"; break; } return $sSql; } protected function makeMaxColTblSql($sDbmsId, $aConnectDef) { $sSql = null; switch ($sDbmsId) { case self::S_ORCL: $sSql = "select table_name, count(*) as col_count
                         from all_tab_columns
                         where owner = '" . strtoupper($aConnectDef['User Name']) . "'
                         group by table_name
                         order by 2 desc"; break; case self::S_PSQL: $sSql = "select table_name, count(*) as \"COL_COUNT\"
                         from information_schema.columns
                         where table_schema = 'public'
                         group by table_name
                         order by 2 desc"; break; case self::S_SQL_SERVER: $sSql = "select table_name, count(*) as \"COL_COUNT\"
                         from information_schema.columns
                         group by table_name
                         order by 2 desc"; break; } return $sSql; } protected function listTblCol($oDb, $sSql) { $oSql = $oDb->execSql($sSql); $aTblCol = array(); while ($aCol = $oDb->getRec($oSql)) { if (!array_key_exists($aCol["TABLE_NAME"], $aTblCol)) { $aTblCol[$aCol["TABLE_NAME"]] = array(); } $aTblCol[$aCol["TABLE_NAME"]][$aCol["COLUMN_NAME"]] = null; } if (count($aTblCol) == 0) { trigger_error("The database does not have a table with column.", E_USER_ERROR); } return $aTblCol; } public function makeDbRef($sTbl, $sCol, $sSql) { return array('sTbl' => $sTbl, 'sCol' => $sCol, 'sSql' => $sSql, 'sSqlId' => 'sql_' . $this->iDbRefCount++); } } ?>
