<?php
 require_once($GLOBALS['sLibDir'] . "class.Util.php"); require_once($GLOBALS['sLibDir'] . "class.Json.php"); require_once($GLOBALS['sLibDir'] . "class.Dbms.php"); class DbmsDb { protected $sDbmsDbFileSpec = null; protected $aDbmsDb = null; public function __construct() { $this->sDbmsDbFileSpec = $GLOBALS['sLinkerDir'] . "data/dbmsDb.json"; $this->aDbmsDb = (file_exists($this->sDbmsDbFileSpec) ? $this->impData($this->sDbmsDbFileSpec) : array()); } public function impData($sFileSpec) { return Json::loadJsonFile($sFileSpec); } public function getDbmsDb() { return $this->aDbmsDb; } public function saveData($aDbmsDb) { $fhDbmsDb = fopen($this->sDbmsDbFileSpec, 'w'); fwrite($fhDbmsDb, $aDbmsDb); fclose($fhDbmsDb); } public function getSlctdDbmsId() { return $this->aDbmsDb['sSlctdDbmsId']; } public function getSlctdDbId($sDbmsId=null) { $sDbmsIdToUse = (is_null($sDbmsId) ? $this->getSlctdDbmsId() : $sDbmsId); return (array_key_exists($sDbmsIdToUse, $this->aDbmsDb['oSlctdDb']) ? $this->aDbmsDb['oSlctdDb'][$sDbmsIdToUse] : null); } public function getSlctdCllctnId($sDbmsId=null, $sDbId=null) { $sCllctnId = null; $sDbmsIdToUse = (is_null($sDbmsId) ? $this->getSlctdDbmsId() : $sDbmsId); $sDbIdToUse = (is_null($sDbId) ? $this->getSlctdDbId() : $sDbId); if (array_key_exists($sDbmsIdToUse, $this->aDbmsDb['oDbms'])) { if (array_key_exists($sDbIdToUse, $this->aDbmsDb['oDbms'][$sDbmsIdToUse])) { $sCllctnId = $this->aDbmsDb['oDbms'][$sDbmsIdToUse][$sDbIdToUse]['oLinkage']['sSlctdCllctnId']; } else { trigger_error("INTERNAL ERROR: Unrecognized database id - \"{$sDbIdToUse}\".", E_USER_ERROR); } } else { trigger_error("INTERNAL ERROR: Unrecognized DBMS id - \"{$sDbmsIdToUse}\".", E_USER_ERROR); } return $sCllctnId; } public function getCllctnInfo($sDbmsId, $sDbId, $sCllctnId) { $aInfo = array('sDbmsName' => '', 'sDbName' => '', 'sCllctnName' => '', 'aConnectDef' => array(), 'sPrimTbl' => null, 'aTblPrimCol' => array(), 'aTblPath' => array() ); if (array_key_exists($sDbmsId, $this->aDbmsDb['oDbms'])) { if (array_key_exists($sDbId, $this->aDbmsDb['oDbms'][$sDbmsId])) { if (array_key_exists($sCllctnId, $this->aDbmsDb['oDbms'][$sDbmsId][$sDbId]['oLinkage'] ['oCllctnLinkage'])) { $aInfo['sDbmsName'] = $sDbmsId; $aInfo['sDbName'] = $this->aDbmsDb['oDbms'][$sDbmsId][$sDbId] ['sDbName']; $aInfo['sCllctnName'] = $this->aDbmsDb['oDbms'][$sDbmsId] [$sDbId] ['oLinkage'] ['oCllctnLinkage'] [$sCllctnId]['sCllctnName']; $aInfo['aConnectDef'] = $this->aDbmsDb['oDbms'][$sDbmsId][$sDbId] ['oConnectParam']; $aPath = $this->aDbmsDb['oDbms'] [$sDbmsId] [$sDbId]['oLinkage']['oCllctnLinkage'][$sCllctnId]; ksort($aPath); $aInfo['aPath'] = $aPath; $bPathFound = false; foreach (array_keys($aPath) as $sPath) { if ($this->isTblPath($sPath)) { if ($bPathFound) { if (is_array($aPath[$sPath])) { foreach ($aPath[$sPath] as $sTbl) { $aInfo['aTblPath'][$sTbl] = $sPath; } } else { $sTbl = $this->getLeafTbl($sPath); $aInfo['aTblPrimCol'][$sTbl] = $aPath[$sPath]; } } else { if ($this->isTblPath($sPath)) { $bPathFound = true; $aInfo['sPrimTbl'] = array_pop($aPath[$sPath]); } } } } } else { trigger_error("INTERNAL ERROR: Unrecognized collection id - \"{$sCllctnId}\".", E_USER_ERROR); } } else { trigger_error("INTERNAL ERROR: Unrecognized database id - \"{$sDbId}\".", E_USER_ERROR); } } else { trigger_error("INTERNAL ERROR: Unrecognized DBMS id - \"{$sDbmsId}\".", E_USER_ERROR); } return $aInfo; } protected function isTblPath($sPath) { return (strpos($sPath, "`") === 0); } protected function getLeafTbl($sPath) { $sTbl = (preg_match("=/([^/]+)$=", $sPath, $aMatch) ? $aMatch[1] : null); return preg_replace("=~[^~]+$=", '', $sTbl); } public function getPathTblColPair($sPath) { $aTblCol = array(); $aLvl = explode('/', $sPath); foreach ($aLvl as $sTblCol) { if (strpos($sTblCol, "~")) { $aField = explode('~', $sTblCol); $aTblCol[] = array('sTbl' => $aField[0], 'sCol' => $aField[1], 'sOrig' => $sTblCol); } } return $aTblCol; } public function findLinkedTblCol() { $aTblCol = array(); foreach (array_keys($this->aDbmsDb['oDbms']) as $sDbms) { foreach (array_keys($this->aDbmsDb['oDbms'][$sDbms]) as $sDb) { $aReqTbl = array(); foreach (array_keys($this->aDbmsDb['oDbms'] [$sDbms][$sDb]['oLinkage']['oCllctnLinkage']) as $sCllctn) { $aTblCol[$sDbms][$sDb]['oCllctn'][$sCllctn] = array(); $aTblCol[$sDbms][$sDb]['oTblCol'] = array(); $aPath = $this->aDbmsDb['oDbms'] [$sDbms][$sDb]['oLinkage']['oCllctnLinkage'][$sCllctn]; ksort($aPath); $bPathFound = false; foreach (array_keys($aPath) as $sPath) { if (!$bPathFound) { $bPathFound = ($sPath == "`"); } if ($bPathFound) { if (is_array($aPath[$sPath])) { foreach ($aPath[$sPath] as $sTbl) { if (!array_key_exists($sTbl, $aTblCol[$sDbms] [$sDb]['oCllctn'][$sCllctn])) { $aTblCol[$sDbms][$sDb]['oCllctn'][$sCllctn][$sTbl] = true; if (!array_key_exists($sTbl, $aTblCol[$sDbms][$sDb]['oTblCol'])) { $aTblCol[$sDbms][$sDb]['oTblCol'][$sTbl] = $this->aDbmsDb['oDbms'] [$sDbms][$sDb]['oMainTbl'][$sTbl]; } } } } } } uksort($aTblCol[$sDbms][$sDb]['oCllctn'], create_function('$sValA, $sValB', 'return strnatcasecmp($sValA, $sValB);')); uksort($aTblCol[$sDbms][$sDb]['oCllctn'][$sCllctn], create_function('$sValA, $sValB', 'return strnatcasecmp($sValA, $sValB);')); uksort($aTblCol[$sDbms][$sDb]['oTblCol'], create_function('$sValA, $sValB', 'return strnatcasecmp($sValA, $sValB);')); } } } return $aTblCol; } } ?>
