<?php
 require_once($GLOBALS['sLibDir'] . "class.Log.php"); require_once($GLOBALS['sLibDir'] . "class.Util.php"); require_once($GLOBALS['sLibDir'] . "class.MefInfo.php"); class Mef { private $sSiteId = "dummy"; private $sSiteName = "dummy"; private $bUseVer2 = false; private $sMefFileSpec; private $oZip = null; function __construct($sSiteId, $sSiteName, $iMefVer=1) { $this->sSiteId = $sSiteId; $this->sSiteName = $sSiteName; $this->bUseVer2 = ($iMefVer == 2); } public function importMef(GnAccess $oGnAccess, MdGen $oMdGen, $sWrkDir=null) { $oLog = Log::getObj(); $bLoginOk = $oGnAccess->checkLogin(); if ($bLoginOk) { $oGnXs = new GnXs($oGnAccess); $aSiteInfo = $oGnXs->getGnSiteInfo(); $oGnCsw = new GnCsw($oGnAccess); while ($aRecAttr = $oMdGen->getNextRec()) { $sMefFileSpec = $this->startMef($sWrkDir); $aCrit = array('sField' => 'apiso:identifier', 'sOpr' => '=', 'sVal' => $aRecAttr['sId']); list($iRecCount, $sRecXml) = $oGnCsw->searchDb($aCrit); if ($iRecCount > 0) { $oGnCsw->delMd($aCrit); } $this->addRec($aRecAttr['sXml'], $aRecAttr['sId']); $this->endMef(); list($aLocalId, $iRetry) = $oGnXs->importMef($sMefFileSpec); unlink($sMefFileSpec); if ($iRetry > 0) { $oLog->genLine("\tNumber of attempts: $iRetry", Log::I_DETAIL); } if (count($aLocalId) > 0) { $oLog->genLine($aRecAttr['sId'] . "\tLocal GeoNetwork id assigned to the imported data: " . join(", ", $aLocalId) ); } } } else { $oLog->genLine("ERROR: Failed to login as \"" . $oGnAccess->getGnUsername() . "\" to the GeoNetwork at \"" . $oGnAccess->getGnUrl() . "\"."); } } public function startMef($sMefDir=null) { $this->sMefFileSpec = (is_null($sMefDir) ? "" : preg_replace("`[/\\\\]+$`", "/", $sMefDir . "/")) . "mef-" . date("YmdHis-") . preg_replace("`\.`", '-', uniqid('', true)) . ".zip"; $this->oZip = new ZipArchive(); if ($this->oZip->open($this->sMefFileSpec, ZIPARCHIVE::CREATE) !== true) { trigger_error("<p>Cannot create the file: {$sMefFileSpec}</p>", E_USER_ERROR); } return $this->sMefFileSpec; } public function addRec($sMetadataXml, $sFileId=null) { $oMefInfo = new MefInfo(); $this->oZip->addFromString(($this->bUseVer2 ? $sFileId . "/" : "") . "info.xml", $oMefInfo->makeXml(time(), time(), $sFileId, $this->sSiteId, $this->sSiteName)); $this->oZip->addFromString(($this->bUseVer2 ? $sFileId . "/metadata/" : "") . "metadata.xml", $sMetadataXml); } public function endMef() { if ($this->oZip) { $this->oZip->close(); if (!file_exists($this->sMefFileSpec)) { trigger_error("Problem in creating the MEF file: {$this->sMefFileSpec}", E_USER_ERROR); } } return; } } ?>
