var DocStr = function() {this.oData = {"element":{"AbstractCoordinateOperation (gml:)":["gml:AbstractCoordinateOperation is a mathematical operation on coordinates that transforms or converts coordinates to another coordinate reference system. Many but not all coordinate operations (from CRS A to CRS B) also uniquely define the inverse operation (from CRS B to CRS A). In some cases, the operation method algorithm for the inverse operation is the same as for the forward algorithm, but the signs of some operation parameter values shall be reversed. In other cases, different algorithms are required for the forward and inverse operations, but the same operation parameter values are used. If (some) entirely different parameter values are needed, a different coordinate operation shall be defined.\nThe optional coordinateOperationAccuracy property elements provide estimates of the impact of this coordinate operation on point position accuracy."],"AbstractGeneralConversion (gml:)":["gm:AbstractGeneralConversion is an abstract operation on coordinates that does not include any change of datum. The best-known example of a coordinate conversion is a map projection. The parameters describing coordinate conversions are defined rather than empirically derived. Note that some conversions have no parameters. The operationVersion, sourceCRS, and targetCRS elements are omitted in a coordinate conversion.\nThis abstract complex type is expected to be extended for well-known operation methods with many Conversion instances, in GML Application Schemas that define operation-method-specialized element names and contents. This conversion uses an operation method, usually with associated parameter values. However, operation methods and parameter values are directly associated with concrete subtypes, not with this abstract type. All concrete types derived from this type shall extend this type to include a \"usesMethod\" element that references the \"OperationMethod\" element. Similarly, all concrete types derived from this type shall extend this type to include zero or more elements each named \"uses...Value\" that each use the type of an element substitutable for the \"AbstractGeneralParameterValue\" element."],"AbstractGeneralOperationParameter (gml:)":["gml:GeneralOperationParameter is the abstract definition of a parameter or group of parameters used by an operation method."],"AbstractGeneralParameterValue (gml:)":["gml:AbstractGeneralParameterValue is an abstract parameter value or group of parameter values.\nThis abstract complexType is expected to be extended and restricted for well-known operation methods with many instances, in Application Schemas that define operation-method-specialized element names and contents. Specific parameter value elements are directly contained in concrete subtypes, not in this abstract type. All concrete types derived from this type shall extend this type to include one \"...Value\" element with an appropriate type, which should be one of the element types allowed in the ParameterValueType. In addition, all derived concrete types shall extend this type to include a \"operationParameter\" property element that references one element substitutable for the \"OperationParameter\" object element."],"AbstractGeneralTransformation (gml:)":["gml:AbstractGeneralTransformation is an abstract operation on coordinates that usually includes a change of Datum. The parameters of a coordinate transformation are empirically derived from data containing the coordinates of a series of points in both coordinate reference systems. This computational process is usually \"over-determined\", allowing derivation of error (or accuracy) estimates for the transformation. Also, the stochastic nature of the parameters may result in multiple (different) versions of the same coordinate transformation. The operationVersion, sourceCRS, and targetCRS proeprty elements are mandatory in a coordinate transformation.\nThis abstract complex type is expected to be extended for well-known operation methods with many Transformation instances, in Application Schemas that define operation-method-specialized value element names and contents. This transformation uses an operation method with associated parameter values. However, operation methods and parameter values are directly associated with concrete subtypes, not with this abstract type. All concrete types derived from this type shall extend this type to include a \"usesMethod\" element that references one \"OperationMethod\" element. Similarly, all concrete types derived from this type shall extend this type to include one or more elements each named \"uses...Value\" that each use the type of an element substitutable for the \"AbstractGeneralParameterValue\" element."],"AbstractSingleOperation (gml:)":["gml:AbstractSingleOperation is a single (not concatenated) coordinate operation."],"Conversion (gml:)":["gml:Conversion is a concrete operation on coordinates that does not include any change of Datum. The best-known example of a coordinate conversion is a map projection. The parameters describing coordinate conversions are defined rather than empirically derived. Note that some conversions have no parameters.\nThis concrete complex type can be used without using a GML Application Schema that defines operation-method-specialized element names and contents, especially for methods with only one Conversion instance.\nThe usesValue property elements are an unordered list of composition associations to the set of parameter values used by this conversion operation."],"OperationMethod (gml:)":["gml:OperationMethod is a method (algorithm or procedure) used to perform a coordinate operation. Most operation methods use a number of operation parameters, although some coordinate conversions use none. Each coordinate operation using the method assigns values to these parameters.\nThe generalOperationParameter elements are an unordered list of associations to the set of operation parameters and parameter groups used by this operation method."],"OperationParameter (gml:)":["gml:OperationParameter is the definition of a parameter used by an operation method. Most parameter values are numeric, but other types of parameter values are possible. This complex type is expected to be used or extended for all operation methods, without defining operation-method-specialized element names."],"OperationParameterGroup (gml:)":["gml:OperationParameterGroup is the definition of a group of parameters used by an operation method. This complex type is expected to be used or extended for all applicable operation methods, without defining operation-method-specialized element names.\nThe generalOperationParameter elements are an unordered list of associations to the set of operation parameters that are members of this group."],"ParameterValue (gml:)":["gml:ParameterValue is a parameter value, an ordered sequence of values, or a reference to a file of parameter values. This concrete complex type may be used for operation methods without using an Application Schema that defines operation-method-specialized element names and contents, especially for methods with only one instance. This complex type may be used, extended, or restricted for well-known operation methods, especially for methods with many instances."],"ParameterValueGroup (gml:)":["gml:ParameterValueGroup is a group of related parameter values. The same group can be repeated more than once in a Conversion, Transformation, or higher level ParameterValueGroup, if those instances contain different values of one or more parameterValues which suitably distinquish among those groups. This concrete complex type can be used for operation methods without using an Application Schema that defines operation-method-specialized element names and contents. This complex type may be used, extended, or restricted for well-known operation methods, especially for methods with only one instance.\nThe parameterValue elements are an unordered set of composition association roles to the parameter values and groups of values included in this group."],"PassThroughOperation (gml:)":["gml:PassThroughOperation is a pass-through operation specifies that a subset of a coordinate tuple is subject to a specific coordinate operation.\nThe modifiedCoordinate property elements are an ordered sequence of positive integers defining the positions in a coordinate tuple of the coordinates affected by this pass-through operation. The AggregationAttributeGroup should be used to specify that the modifiedCoordinate elements are ordered."],"Transformation (gml:)":["gml:Transformation is a concrete object element derived from gml:GeneralTransformation (13.6.2.13).\nThis concrete object can be used for all operation methods, without using a GML Application Schema that defines operation-method-specialized element names and contents, especially for methods with only one Transformation instance.\nThe parameterValue elements are an unordered list of composition associations to the set of parameter values used by this conversion operation."],"booleanValue (gml:)":["gml:booleanValue is a boolean value of an operation parameter. A Boolean value does not have an associated unit of measure."],"coordOperation (gml:)":["gml:coordOperation is an association role to a coordinate operation."],"coordinateOperationAccuracy (gml:)":["gml:coordinateOperationAccuracy is an association role to a DQ_PositionalAccuracy object as encoded in ISO\/TS 19139, either referencing or containing the definition of that positional accuracy. That object contains an estimate of the impact of this coordinate operation on point accuracy. That is, it gives position error estimates for the target coordinates of this coordinate operation, assuming no errors in the source coordinates."],"formula (gml:)":["gml:formula specifies a formula or procedure used by this operation method. The value may be a reference to a publication. Note that the operation method may not be analytic, in which case this element references or contains the procedure, not an analytic formula."],"generalOperationParameter (gml:)":["gml:generalOperationParameter is an association to an operation parameter or parameter group."],"group (gml:)":["gml:group is an association role to the operation parameter group for which this element provides parameter values."],"integerValue (gml:)":["gml:integerValue is a positive integer value of an operation parameter, usually used for a count. An integer value does not have an associated unit of measure."],"integerValueList (gml:)":["gml:integerValueList is an ordered sequence of two or more integer values of an operation parameter list, usually used for counts. These integer values do not have an associated unit of measure. An element of this type contains a space-separated sequence of integer values."],"maximumOccurs (gml:)":["gml:maximumOccurs is the maximum number of times that values for this parameter group may be included. If this attribute is omitted, the maximum number shall be one."],"method (gml:)":["gml:method is an association role to the operation method used by a coordinate operation."],"minimumOccurs (gml:)":["gml:minimumOccurs is the minimum number of times that values for this parameter group or parameter are required. If this attribute is omitted, the minimum number shall be one."],"modifiedCoordinate (gml:)":["gml:modifiedCoordinate is a positive integer defining a position in a coordinate tuple."],"operationParameter (gml:)":["gml:operationParameter is an association role to the operation parameter of which this is a value."],"operationVersion (gml:)":["gml:operationVersion is the version of the coordinate transformation (i.e., instantiation due to the stochastic nature of the parameters). Mandatory when describing a transformation, and should not be supplied for a conversion."],"parameterValue (gml:)":["gml:parameterValue is a composition association to a parameter value or group of parameter values used by a coordinate operation."],"sourceCRS (gml:)":["gml:sourceCRS is an association role to the source CRS (coordinate reference system) of this coordinate operation."],"sourceDimensions (gml:)":["gml:sourceDimensions is the number of dimensions in the source CRS of this operation method."],"stringValue (gml:)":["gml:stringValue is a character string value of an operation parameter. A string value does not have an associated unit of measure."],"targetCRS (gml:)":["gml:targetCRS is an association role to the target CRS (coordinate reference system) of this coordinate operation."],"targetDimensions (gml:)":["gml:targetDimensions is the number of dimensions in the target CRS of this operation method."],"usesOperation (gml:)":["gml:usesOperation is deprecated, gml:coordOperation shall be used instead."],"value (gml:)":["gml:value is a numeric value of an operation parameter, with its associated unit of measure."],"valueFile (gml:)":["gml:valueFile is a reference to a file or a part of a file containing one or more parameter values, each numeric value with its associated unit of measure. When referencing a part of a file, that file shall contain multiple identified parts, such as an XML encoded document. Furthermore, the referenced file or part of a file may reference another part of the same or different files, as allowed in XML documents."],"valueList (gml:)":["gml:valueList is an ordered sequence of two or more numeric values of an operation parameter list, where each value has the same associated unit of measure. An element of this type contains a space-separated sequence of double values."],"AbstractGeneralDerivedCRS (gml:)":["gml:AbstractGeneralDerivedCRS is a coordinate reference system that is defined by its coordinate conversion from another coordinate reference system. This abstract complex type shall not be used, extended, or restricted, in a GML Application Schema, to define a concrete subtype with a meaning equivalent to a concrete subtype specified in this document."],"AbstractSingleCRS (gml:)":["gml:AbstractSingleCRS implements a coordinate reference system consisting of one coordinate system and one datum (as opposed to a Compound CRS)."],"CompoundCRS (gml:)":["gml:CompundCRS is a coordinate reference system describing the position of points through two or more independent coordinate reference systems. It is associated with a non-repeating sequence of two or more instances of SingleCRS."],"DerivedCRS (gml:)":["gml:DerivedCRS is a single coordinate reference system that is defined by its coordinate conversion from another single coordinate reference system known as the base CRS. The base CRS can be a projected coordinate reference system, if this DerivedCRS is used for a georectified grid coverage as described in ISO 19123, Clause 8."],"EngineeringCRS (gml:)":["gml:EngineeringCRS is a contextually local coordinate reference system which can be divided into two broad categories:\n-\tearth-fixed systems applied to engineering activities on or near the surface of the earth;\n-\tCRSs on moving platforms such as road vehicles, vessels, aircraft, or spacecraft, see ISO 19111 8.3."],"ImageCRS (gml:)":["gml:ImageCRS is an engineering coordinate reference system applied to locations in images. Image coordinate reference systems are treated as a separate sub-type because the definition of the associated image datum contains two attributes not relevant to other engineering datums."],"ProjectedCRS (gml:)":["gml:ProjectedCRS is a 2D coordinate reference system used to approximate the shape of the earth on a planar surface, but in such a way that the distortion that is inherent to the approximation is carefully controlled and known. Distortion correction is commonly applied to calculated bearings and distances to produce values that are a close match to actual field values."],"TemporalCRS (gml:)":["gml:TemporalCRS is a 1D coordinate reference system used for the recording of time."],"VerticalCRS (gml:)":["gml:VerticalCRS is a 1D coordinate reference system used for recording heights or depths. Vertical CRSs make use of the direction of gravity to define the concept of height or depth, but the relationship with gravity may not be straightforward. By implication, ellipsoidal heights (h) cannot be captured in a vertical coordinate reference system. Ellipsoidal heights cannot exist independently, but only as an inseparable part of a 3D coordinate tuple defined in a geographic 3D coordinate reference system."],"affineCS (gml:)":["gml:affineCS is an association role to the affine coordinate system used by this CRS."],"baseCRS (gml:)":["gml:baseCRS is an association role to the coordinate reference system used by this derived CRS."],"baseGeodeticCRS (gml:)":["gml:baseGeodeticCRS is an association role to the geodetic coordinate reference system used by this projected CRS."],"cartesianCS (gml:)":["gml:cartesianCS is an association role to the Cartesian coordinate system used by this CRS."],"componentReferenceSystem (gml:)":["The gml:componentReferenceSystem elements are an ordered sequence of associations to all the component coordinate reference systems included in this compound coordinate reference system. The gml:AggregationAttributeGroup should be used to specify that the gml:componentReferenceSystem properties are ordered."],"conversion (gml:)":["gml:conversion is an association role to the coordinate conversion used to define the derived CRS."],"coordinateSystem (gml:)":["An association role to the coordinate system used by this CRS."],"derivedCRSType (gml:)":["The gml:derivedCRSType property describes the type of a derived coordinate reference system. The required codeSpace attribute shall reference a source of information specifying the values and meanings of all the allowed string values for this property."],"ellipsoidalCS (gml:)":["gml:ellipsoidalCS is an association role to the ellipsoidal coordinate system used by this CRS."],"engineeringDatum (gml:)":["gml:engineeringDatum is an association role to the engineering datum used by this CRS."],"geodeticDatum (gml:)":["gml:geodeticDatum is an association role to the geodetic datum used by this CRS.\n"],"imageDatum (gml:)":["gml:imageDatum is an association role to the image datum used by this CRS."],"sphericalCS (gml:)":["gml:sphericalCS is an association role to the spherical coordinate system used by this CRS."],"temporalDatum (gml:)":["gml:temporalDatum is an association role to the temporal datum used by this CRS."],"timeCS (gml:)":["gml:timeCS is an association role to the time coordinate system used by this CRS."],"verticalCS (gml:)":["gml:verticalCS is an association role to the vertical coordinate system used by this CRS."],"verticalDatum (gml:)":["gml:verticalDatum is an association role to the vertical datum used by this CRS."],"AbstractCoordinateSystem (gml:)":["gml:AbstractCoordinateSystem is a coordinate system (CS) is the non-repeating sequence of coordinate system axes that spans a given coordinate space. A CS is derived from a set of mathematical rules for specifying how coordinates in a given space are to be assigned to points. The coordinate values in a coordinate tuple shall be recorded in the order in which the coordinate system axes associations are recorded. This abstract complex type shall not be used, extended, or restricted, in an Application Schema, to define a concrete subtype with a meaning equivalent to a concrete subtype specified in this document."],"AffineCS (gml:)":["gml:AffineCS is a two- or three-dimensional coordinate system with straight axes that are not necessarily orthogonal. An AffineCS shall have two or three gml:axis property elements; the number of property elements shall equal the dimension of the CS."],"CartesianCS (gml:)":["gml:CartesianCS is a 1-, 2-, or 3-dimensional coordinate system. In the 1-dimensional case, it contains a single straight coordinate axis. In the 2- and 3-dimensional cases gives the position of points relative to orthogonal straight axes. In the multi-dimensional case, all axes shall have the same length unit of measure. A CartesianCS shall have one, two, or three gml:axis property elements."],"CoordinateSystemAxis (gml:)":["gml:CoordinateSystemAxis is a definition of a coordinate system axis."],"CylindricalCS (gml:)":["gml:CylindricalCS is a three-dimensional coordinate system consisting of a polar coordinate system extended by a straight coordinate axis perpendicular to the plane spanned by the polar coordinate system. A CylindricalCS shall have three gml:axis property elements."],"EllipsoidalCS (gml:)":["gml:EllipsoidalCS is a two- or three-dimensional coordinate system in which position is specified by geodetic latitude, geodetic longitude, and (in the three-dimensional case) ellipsoidal height. An EllipsoidalCS shall have two or three gml:axis property elements; the number of associations shall equal the dimension of the CS."],"LinearCS (gml:)":["gml:LinearCS is a one-dimensional coordinate system that consists of the points that lie on the single axis described. The associated coordinate is the distance &#8211; with or without offset &#8211; from the specified datum to the point along the axis. A LinearCS shall have one gml:axis property element."],"PolarCS (gml:)":["gml:PolarCS ia s two-dimensional coordinate system in which position is specified by the distance from the origin and the angle between the line from the origin to a point and a reference direction. A PolarCS shall have two gml:axis property elements."],"SphericalCS (gml:)":["gml:SphericalCS is a three-dimensional coordinate system with one distance measured from the origin and two angular coordinates. A SphericalCS shall have three gml:axis property elements."],"TimeCS (gml:)":["gml:TimeCS is a one-dimensional coordinate system containing a time axis, used to describe the temporal position of a point in the specified time units from a specified time origin. A TimeCS shall have one gml:axis property element."],"UserDefinedCS (gml:)":["gml:UserDefinedCS is a two- or three-dimensional coordinate system that consists of any combination of coordinate axes not covered by any other coordinate system type. A UserDefinedCS shall have two or three gml:axis property elements; the number of property elements shall equal the dimension of the CS."],"VerticalCS (gml:)":["gml:VerticalCS is a one-dimensional coordinate system used to record the heights or depths of points. Such a coordinate system is usually dependent on the Earth's gravity field, perhaps loosely as when atmospheric pressure is the basis for the vertical coordinate system axis. A VerticalCS shall have one gml:axis property element."],"axis (gml:)":["The gml:axis property is an association role (ordered sequence) to the coordinate system axes included in this coordinate system. The coordinate values in a coordinate tuple shall be recorded in the order in which the coordinate system axes associations are recorded, whenever those coordinates use a coordinate reference system that uses this coordinate system. The gml:AggregationAttributeGroup should be used to specify that the axis objects are ordered."],"axisAbbrev (gml:)":["gml:axisAbbrev is the abbreviation used for this coordinate system axis; this abbreviation is also used to identify the coordinates in the coordinate tuple. The codeSpace attribute may reference a source of more information on a set of standardized abbreviations, or on this abbreviation."],"axisDirection (gml:)":["gml:axisDirection is the direction of this coordinate system axis (or in the case of Cartesian projected coordinates, the direction of this coordinate system axis at the origin).\nWithin any set of coordinate system axes, only one of each pair of terms may be used. For earth-fixed CRSs, this direction is often approximate and intended to provide a human interpretable meaning to the axis. When a geodetic datum is used, the precise directions of the axes may therefore vary slightly from this approximate direction.\nThe codeSpace attribute shall reference a source of information specifying the values and meanings of all the allowed string values for this property."],"maximumValue (gml:)":["The gml:minimumValue and gml:maximumValue properties allow the specification of minimum and maximum value normally allowed for this axis, in the unit of measure for the axis. For a continuous angular axis such as longitude, the values wrap-around at this value. Also, values beyond this minimum\/maximum can be used for specified purposes, such as in a bounding box. A value of minus infinity shall be allowed for the gml:minimumValue element, a value of plus infiniy for the gml:maximumValue element. If these elements are omitted, the value is unspecified."],"minimumValue (gml:)":["The gml:minimumValue and gml:maximumValue properties allow the specification of minimum and maximum value normally allowed for this axis, in the unit of measure for the axis. For a continuous angular axis such as longitude, the values wrap-around at this value. Also, values beyond this minimum\/maximum can be used for specified purposes, such as in a bounding box. A value of minus infinity shall be allowed for the gml:minimumValue element, a value of plus infiniy for the gml:maximumValue element. If these elements are omitted, the value is unspecified."],"rangeMeaning (gml:)":["gml:rangeMeaning describes the meaning of axis value range specified by gml:minimumValue and gml:maximumValue. This element shall be omitted when both gml:minimumValue and gml:maximumValue are omitted. This element should be included when gml:minimumValue and\/or gml:maximumValue are included. If this element is omitted when the gml:minimumValue and\/or gml:maximumValue are included, the meaning is unspecified. The codeSpace attribute shall reference a source of information specifying the values and meanings of all the allowed string values for this property."],"AbstractContinuousCoverage (gml:)":["A continuous coverage as defined in ISO 19123 is a coverage that can return different values for the same feature attribute at different direct positions within a single spatiotemporal object in its spatiotemporal domain. The base type for continuous coverages is AbstractContinuousCoverageType.\nThe coverageFunction element describes the mapping function.\nThe abstract element gml:AbstractContinuousCoverage serves as the head of a substitution group which may contain any continuous coverage whose type is derived from gml:AbstractContinuousCoverageType."],"AbstractCoverage (gml:)":["This element serves as the head of a substitution group which may contain any coverage whose type is derived from gml:AbstractCoverageType.  It may act as a variable in the definition of content models where it is required to permit any coverage to be valid."],"AbstractDiscreteCoverage (gml:)":["A discrete coverage consists of a domain set, range set and optionally a coverage function. The domain set consists of either spatial or temporal geometry objects, finite in number. The range set is comprised of a finite number of attribute values each of which is associated to every direct position within any single spatiotemporal object in the domain. In other words, the range values are constant on each spatiotemporal object in the domain. This coverage function maps each element from the coverage domain to an element in its range. The coverageFunction element describes the mapping function.\nThis element serves as the head of a substitution group which may contain any discrete coverage whose type is derived from gml:AbstractDiscreteCoverageType."],"CoverageMappingRule (gml:)":["gml:CoverageMappingRule provides a formal or informal description of the coverage function.\nThe mapping rule may be defined as an in-line string (gml:ruleDefinition) or via a remote reference through xlink:href (gml:ruleReference).\nIf no rule name is specified, the default is &#8216;Linear&#8217; with respect to members of the domain in document order."],"DataBlock (gml:)":["gml:DataBlock describes the Range as a block of text encoded values similar to a Common Separated Value (CSV) representation.\nThe range set parameterization is described by the property gml:rangeParameters."],"File (gml:)":["for efficiency reasons, GML also provides a means of encoding the range set in an arbitrary external encoding, such as a binary file.  This encoding may be &#8220;well-known&#8221; but this is not required. This mode uses the gml:File element.\nThe values of the coverage (attribute values in the range set) are transmitted in a external file that is referenced from the XML structure described by gml:FileType.  The external file is referenced by the gml:fileReference property that is an anyURI (the gml:fileName property has been deprecated).  This means that the external file may be located remotely from the referencing GML instance.\nThe gml:compression property points to a definition of a compression algorithm through an anyURI.  This may be a retrievable, computable definition or simply a reference to an unambiguous name for the compression method.\nThe gml:mimeType property points to a definition of the file mime type.\nThe gml:fileStructure property is defined by the gml:FileValueModelType.  This is simple enumerated type restriction on string.  The only value supported in GML is &#8220;Record Interleaved&#8221;.  Additional values may be supported in future releases of GML.  Note further that all values shall be enclosed in a single file. Multi-file structures for values are not supported in GML.\nThe semantics of the range set is described as above using the gml:rangeParameters property.\nNote that if any compression algorithm is applied, the structure above applies only to the pre-compression or post-decompression structure of the file.\nNote that the fields within a record match the gml:valueComponents of the gml:CompositeValue in document order."],"GridCoverage (gml:)":["A gml:GriddedCoverage is a discrete point coverage in which the domain set is a geometric grid of points.\nNote that this is the same as the gml:MultiPointCoverage except that we have a gml:gridDomain property to describe the domain.\nThe simple gridded coverage is not geometrically referenced and hence no geometric positions are assignable to the points in the grid. Such geometric positioning is introduced in the gml:RectifiedGridCoverage."],"GridFunction (gml:)":["gml:GridFunction provides an explicit mapping rule for grid geometries, i.e. the domain shall be a geometry of type grid.  It describes the mapping of grid posts (discrete point grid coverage) or grid cells (discrete surface coverage) to the values in the range set.\nThe gml:startPoint is the index position of a point in the grid that is mapped to the first point in the range set (this is also the index position of the first grid post).  If the gml:startPoint property is omitted the gml:startPoint is assumed to be equal to the value of gml:low in the gml:Grid geometry. Subsequent points in the mapping are determined by the value of the gml:sequenceRule."],"MultiCurveCoverage (gml:)":["In a gml:MultiCurveCoverage the domain is partioned into a collection of curves comprising a gml:MultiCurve.  The coverage function then maps each curve in the collection to a value in the range set.\nThe content model is derived by restriction from gml:AbstractDiscreteCoverageType. Note that the restriction replaces the generic gml:domainSet by the specific gml:multiCurveDomain whose value is a gml:MultiCurve.\nIn a gml:MultiCurveCoverage the mapping from the domain to the range is straightforward.\n-       For gml:DataBlock encodings the curves of the gml:MultiCurve are mapped in document order to the tuples of the data block.\n-       For gml:CompositeValue encodings the curves of the gml:MultiCurve are mapped to the members of the composite value in document order.\n-       For gml:File encodings the curves of the gml:MultiCurve are mapped to the records of the file in sequential order.\n"],"MultiPointCoverage (gml:)":["In a gml:MultiPointCoverage the domain set is a gml:MultiPoint, that is a collection of arbitrarily distributed geometric points.\nThe content model is derived by restriction from gml:AbstractDiscreteCoverageType. Note that the restriction replaces the generic gml:domainSet by the specific gml:multiPointDomain whose value is a gml:MultiPoint.\nIn a gml:MultiPointCoverage the mapping from the domain to the range is straightforward.\n-       For gml:DataBlock encodings the points of the gml:MultiPoint are mapped in document order to the tuples of the data block.\n-       For gml:CompositeValue encodings the points of the gml:MultiPoint are mapped to the members of the composite value in document order.\n-       For gml:File encodings the points of the gml:MultiPoint are mapped to the records of the file in sequential order.\n"],"MultiSolidCoverage (gml:)":["In a gml:MultiSolidCoverage the domain is partioned into a collection of solids comprising a gml:MultiSolid.  The coverage function than maps each solid in the collection to a value in the range set.\nThe content model is derived by restriction from gml:AbstractDiscreteCoverageType. Note that the restriction replaces the generic gml:domainSet by the specific gml:multiSolidDomain whose value is a gml:MultiSolid.\nIn a gml:MultiSolidCoverage the mapping from the domain to the range is straightforward.\n-       For gml:DataBlock encodings the solids of the gml:MultiSolid are mapped in document order to the tuples of the data block.\n-       For gml:CompositeValue encodings the solids of the gml:MultiSolid are mapped to the members of the composite value in document order.\n-       For gml:File encodings the solids of the gml:MultiSolid are mapped to the records of the file in sequential order.\n"],"MultiSurfaceCoverage (gml:)":["In a gml:MultiSurfaceCoverage the domain is partioned into a collection of surfaces comprising a gml:MultiSurface.  The coverage function than maps each surface in the collection to a value in the range set.\nThe content model is derived by restriction from gml:AbstractDiscreteCoverageType. Note that the restriction replaces the generic gml:domainSet by the specific gml:multiSurfaceDomain whose value is a gml:MultiSurface.\nIn a gml:MultiSurfaceCoverage the mapping from the domain to the range is straightforward.\n-       For gml:DataBlock encodings the surfaces of the gml:MultiSurface are mapped in document order to the tuples of the data block.\n-       For gml:CompositeValue encodings the surfaces of the gml:MultiSurface are mapped to the members of the composite value in document order.\n-       For gml:File encodings the surfaces of the gml:MultiSurface are mapped to the records of the file in sequential order.\n"],"RectifiedGridCoverage (gml:)":["The gml:RectifiedGridCoverage is a discrete point coverage based on a rectified grid. It is similar to the grid coverage except that the points of the grid are geometrically referenced. The rectified grid coverage has a domain that is a gml:RectifiedGrid geometry.\nThe coverage domain is described by gml:rectifiedGridDomain."],"coverageFunction (gml:)":["The gml:coverageFunction property describes the mapping function from the domain to the range of the coverage.\nThe value of the CoverageFunction is one of gml:CoverageMappingRule and gml:GridFunction.\nIf the gml:coverageFunction property is omitted for a gridded coverage (including rectified gridded coverages) the gml:startPoint is assumed to be the value of the gml:low property in the gml:Grid geometry, and the gml:sequenceRule is assumed to be linear and the gml:axisOrder property is assumed to be &#8220;+1 +2&#8221;."],"domainSet (gml:)":["The gml:domainSet property element describes the spatio-temporal region of interest, within which the coverage is defined. Its content model is given by gml:DomainSetType.\nThe value of the domain is thus a choice between a gml:AbstractGeometry and a gml:AbstractTimeObject.  In the instance these abstract elements will normally be substituted by a geometry complex or temporal complex, to represent spatial coverages and time-series, respectively.\nThe presence of the gml:AssociationAttributeGroup means that domainSet follows the usual GML property model and may use the xlink:href attribute to point to the domain, as an alternative to describing the domain inline. Ownership semantics may be provided using the gml:OwnershipAttributeGroup.\n"],"doubleOrNilReasonTupleList (gml:)":["gml:doubleOrNilReasonList consists of a list of gml:doubleOrNilReason values, each separated by a whitespace. The gml:doubleOrNilReason values are grouped into tuples where the dimension of each tuple in the list is equal to the number of range parameters."],"rangeSet (gml:)":["The gml:rangeSet property element contains the values of the coverage (sometimes called the attribute values).  Its content model is given by gml:RangeSetType.\nThis content model supports a structural description of the range.  The semantic information describing the range set is embedded using a uniform method, as part of the explicit values, or as a template value accompanying the representation using gml:DataBlock and gml:File.\nThe values from each component (or &#8220;band&#8221;) in the range may be encoded within a gml:ValueArray element or a concrete member of the gml:AbstractScalarValueList substitution group . Use of these elements satisfies the value-type homogeneity requirement."],"tupleList (gml:)":["gml:CoordinatesType consists of a list of coordinate tuples, with each coordinate tuple separated by the ts or tuple separator (whitespace), and each coordinate in the tuple by the cs or coordinate separator (comma).\nThe gml:tupleList encoding is effectively &#8220;band-interleaved&#8221;."],"AbstractDatum (gml:)":["A gml:AbstractDatum specifies the relationship of a coordinate system to the earth, thus creating a coordinate reference system. A datum uses a parameter or set of parameters that determine the location of the origin of the coordinate reference system. Each datum subtype may be associated with only specific types of coordinate systems. This abstract complex type shall not be used, extended, or restricted, in a GML Application Schema, to define a concrete subtype with a meaning equivalent to a concrete subtype specified in this document."],"Ellipsoid (gml:)":["A gml:Ellipsoid is a geometric figure that may be used to describe the approximate shape of the earth. In mathematical terms, it is a surface formed by the rotation of an ellipse about its minor axis."],"EngineeringDatum (gml:)":["gml:EngineeringDatum defines the origin of an engineering coordinate reference system, and is used in a region around that origin. This origin may be fixed with respect to the earth (such as a defined point at a construction site), or be a defined point on a moving vehicle (such as on a ship or satellite)."],"GeodeticDatum (gml:)":["gml:GeodeticDatum is a geodetic datum defines the precise location and orientation in 3-dimensional space of a defined ellipsoid (or sphere), or of a Cartesian coordinate system centered in this ellipsoid (or sphere)."],"ImageDatum (gml:)":["gml:ImageDatum defines the origin of an image coordinate reference system, and is used in a local context only. For an image datum, the anchor definition is usually either the centre of the image or the corner of the image. For more information, see ISO 19111 B.3.5."],"PrimeMeridian (gml:)":["A gml:PrimeMeridian defines the origin from which longitude values are determined. The default value for the prime meridian gml:identifier value is \"Greenwich\"."],"TemporalDatum (gml:)":["A gml:TemporalDatum defines the origin of a Temporal Reference System. This type omits the \"anchorDefinition\" and \"realizationEpoch\" elements and adds the \"origin\" element with the dateTime type."],"VerticalDatum (gml:)":["gml:VerticalDatum is a textual description and\/or a set of parameters identifying a particular reference level surface used as a zero-height surface, including its position with respect to the Earth for any of the height types recognized by this International Standard."],"anchorDefinition (gml:)":["gml:anchorDefinition is a description, possibly including coordinates, of the definition used to anchor the datum to the Earth. Also known as the \"origin\", especially for engineering and image datums. The codeSpace attribute may be used to reference a source of more detailed on this point or surface, or on a set of such descriptions.\n-\tFor a geodetic datum, this point is also known as the fundamental point, which is traditionally the point where the relationship between geoid and ellipsoid is defined. In some cases, the \"fundamental point\" may consist of a number of points. In those cases, the parameters defining the geoid\/ellipsoid relationship have been averaged for these points, and the averages adopted as the datum definition.\n-\tFor an engineering datum, the anchor definition may be a physical point, or it may be a point with defined coordinates in another CRS.may\n-\tFor an image datum, the anchor definition is usually either the centre of the image or the corner of the image.\n-\tFor a temporal datum, this attribute is not defined. Instead of the anchor definition, a temporal datum carries a separate time origin of type DateTime."],"ellipsoid (gml:)":["gml:ellipsoid is an association role to the ellipsoid used by this geodetic datum."],"greenwichLongitude (gml:)":["gml:greenwichLongitude is the longitude of the prime meridian measured from the Greenwich meridian, positive eastward. If the value of the prime meridian &#8220;name&#8221; is \"Greenwich\" then the value of greenwichLongitude shall be 0 degrees."],"origin (gml:)":["gml:origin is the date and time origin of this temporal datum."],"pixelInCell (gml:)":["gml:pixelInCell is a specification of the way an image grid is associated with the image data attributes. The required codeSpace attribute shall reference a source of information specifying the values and meanings of all the allowed string values for this property."],"primeMeridian (gml:)":["gml:primeMeridian is an association role to the prime meridian used by this geodetic datum."],"realizationEpoch (gml:)":["gml:realizationEpoch is the time after which this datum definition is valid. See ISO 19111 Table 32 for details."],"secondDefiningParameter (gml:)":["gml:secondDefiningParameter is a property containing the definition of the second parameter that defines the shape of an ellipsoid. An ellipsoid requires two defining parameters: semi-major axis and inverse flattening or semi-major axis and semi-minor axis. When the reference body is a sphere rather than an ellipsoid, only a single defining parameter is required, namely the radius of the sphere; in that case, the semi-major axis \"degenerates\" into the radius of the sphere.\nThe inverseFlattening element contains the inverse flattening value of the ellipsoid. This value is a scale factor (or ratio). It uses gml:LengthType with the restriction that the unit of measure referenced by the uom attribute must be suitable for a scale factor, such as percent, permil, or parts-per-million.\nThe semiMinorAxis element contains the length of the semi-minor axis of the ellipsoid. When the isSphere element is included, the ellipsoid is degenerate and is actually a sphere. The sphere is completely defined by the semi-major axis, which is the radius of the sphere."],"semiMajorAxis (gml:)":["gml:semiMajorAxis specifies the length of the semi-major axis of the ellipsoid, with its units. Uses the MeasureType with the restriction that the unit of measure referenced by uom must be suitable for a length, such as metres or feet."],"Definition (gml:)":["The basic gml:Definition element specifies a definition, which can be included in or referenced by a dictionary. \nThe content model for a generic definition is a derivation from gml:AbstractGMLType.  \nThe gml:description property element shall hold the definition if this can be captured in a simple text string, or the gml:descriptionReference property element may carry a link to a description elsewhere.\nThe gml:identifier element shall provide one identifier identifying this definition. The identifier shall be unique within the dictionaries using this definition. \nThe gml:name elements shall provide zero or more terms and synonyms for which this is the definition.\nThe gml:remarks element shall be used to hold additional textual information that is not conceptually part of the definition but is useful in understanding the definition."],"Dictionary (gml:)":["Sets of definitions may be collected into dictionaries or collections.\nA gml:Dictionary is a non-abstract collection of definitions.\nThe gml:Dictionary content model adds a list of gml:dictionaryEntry properties that contain or reference gml:Definition objects.  A database handle (gml:id attribute) is required, in order that this collection may be referred to. The standard gml:identifier, gml:description, gml:descriptionReference and gml:name properties are available to reference or contain more information about this dictionary. The gml:description and gml:descriptionReference property elements may be used for a description of this dictionary. The derived gml:name element may be used for the name(s) of this dictionary. for remote definiton references gml:dictionaryEntry shall be used. If a Definition object contained within a Dictionary uses the descriptionReference property to refer to a remote definition, then this enables the inclusion of a remote definition in a local dictionary, giving a handle and identifier in the context of the local dictionary."],"dictionaryEntry (gml:)":["This property element contains or refers to the definitions which are members of a dictionary. \nThe content model follows the standard GML property pattern, so a gml:dictionaryEntry may either contain or refer to a single gml:Definition. Since gml:Dictionary is substitutable for gml:Definition, the content of an entry may itself be a lower level dictionary. \nNote that if the value is provided by reference, this definition does not carry a handle (gml:id) in this context, so does not allow external references to this specific definition in this context.  When used in this way the referenced definition will usually be in a dictionary in the same XML document."],"direction (gml:)":["The property gml:direction is intended as a pre-defined property expressing a direction to be assigned to features defined in a GML application schema."],"AbstractTimeSlice (gml:)":["To describe an event &#8212; an action that occurs at an instant or over an interval of time &#8212; GML provides the gml:AbtractTimeSlice element. A timeslice encapsulates the time-varying properties of a dynamic feature -- it shall be extended to represent a time stamped projection of a specific feature. The gml:dataSource property describes how the temporal data was acquired.\nA gml:AbstractTimeSlice instance is a GML object that encapsulates updates of the dynamic&#8212;or volatile&#8212;properties that reflect some change event; it thus includes only those feature properties that have actually changed due to some process.\ngml:AbstractTimeSlice basically provides a facility for attribute-level time stamping, in contrast to the object-level time stamping of dynamic feature instances. \nThe time slice can thus be viewed as event or process-oriented, whereas a snapshot is more state or structure-oriented. A timeslice has richer causality, whereas a snapshot merely portrays the status of the whole. \n"],"DynamicFeature (gml:)":["States are captured by time-stamped instances of a feature. The content model extends the standard gml:AbstractFeatureType with the gml:dynamicProperties model group.\nEach time-stamped instance represents a &#8216;snapshot&#8217; of a feature. The dynamic feature classes will normally be extended to suit particular applications.  A dynamic feature bears either a time stamp or a history."],"DynamicFeatureCollection (gml:)":["A gml:DynamicFeatureCollection is a feature collection that has a gml:validTime property (i.e. is a snapshot of the feature collection) or which has a gml:history property that contains one or more gml:AbstractTimeSlices each of which contain values of the time varying properties of the feature collection.  Note that the gml:DynamicFeatureCollection may be one of the following:\n1.\tA feature collection which consists of static feature members (members do not change in time) but which has properties of the collection object as a whole that do change in time .  \n2.\tA feature collection which consists of dynamic feature members (the members are gml:DynamicFeatures) but which also has properties of the collection as a whole that vary in time."],"MovingObjectStatus (gml:)":["gml:MovingObjectStatus is one example of how gml:AbstractTimeSlice may be extended. This element provides a standard method to capture a record of the status of a moving object.\nA gml:MovingObjectStatus element allows the user to describe the present location, along with the speed, bearing, acceleration and elevation of an object in a particular time slice.  \nAdditional information about the current status of the object may be recorded in the gml:status or gml:statusReference property elements."],"dataSource (gml:)":["Evidence is represented by a simple gml:dataSource or gml:dataSourceReference property that indicates the source of the temporal data. The remote link attributes of the gml:dataSource element have been deprecated along with its current type."],"dataSourceReference (gml:)":["Evidence is represented by a simple gml:dataSource or gml:dataSourceReference property that indicates the source of the temporal data."],"history (gml:)":["A generic sequence of events constitute a gml:history of an object.\nThe gml:history element contains a set of elements in the substitution group headed by the abstract element gml:AbstractTimeSlice, representing the time-varying properties of interest. The history property of a dynamic feature associates a feature instance with a sequence of time slices (i.e. change events) that encapsulate the evolution of the feature."],"status (gml:)":["The remote link attributes of the gml:status element have been deprecated along with its current type."],"AbstractFeature (gml:)":["This abstract element serves as the head of a substitution group which may contain any elements whose content model is derived from gml:AbstractFeatureType.  This may be used as a variable in the construction of content models.  \ngml:AbstractFeature may be thought of as &#8220;anything that is a GML feature&#8221; and may be used to define variables or templates in which the value of a GML property is &#8220;any feature&#8221;. This occurs in particular in a GML feature collection where the feature member properties contain one or multiple copies of gml:AbstractFeature respectively."],"EnvelopeWithTimePeriod (gml:)":["gml:EnvelopeWithTimePeriod is provided for envelopes that include a temporal extent. It adds two time position properties, gml:beginPosition and gml:endPosition, which describe the extent of a time-envelope.  \nSince gml:EnvelopeWithTimePeriod is assigned to the substitution group headed by gml:Envelope, it may be used whenever gml:Envelope is valid."],"boundedBy (gml:)":["This property describes the minimum bounding box or rectangle that encloses the entire feature."],"locationName (gml:)":["The gml:locationName property element is a convenience property where the text value describes the location of the feature. If the location names are selected from a controlled list, then the list shall be identified in the codeSpace attribute."],"locationReference (gml:)":["The gml:locationReference property element is a convenience property where the text value referenced by the xlink:href attribute describes the location of the feature."],"AbstractGeometricAggregate (gml:)":["gml:AbstractGeometricAggregate is the abstract head of the substitution group for all geometric aggregates."],"MultiCurve (gml:)":["A gml:MultiCurve is defined by one or more gml:AbstractCurves.\nThe members of the geometric aggregate may be specified either using the \"standard\" property (gml:curveMember) or the array property (gml:curveMembers). It is also valid to use both the \"standard\" and the array properties in the same collection."],"MultiGeometry (gml:)":["gml:MultiGeometry is a collection of one or more GML geometry objects of arbitrary type. \nThe members of the geometric aggregate may be specified either using the \"standard\" property (gml:geometryMember) or the array property (gml:geometryMembers). It is also valid to use both the \"standard\" and the array properties in the same collection."],"MultiPoint (gml:)":["A gml:MultiPoint consists of one or more gml:Points.\nThe members of the geometric aggregate may be specified either using the \"standard\" property (gml:pointMember) or the array property (gml:pointMembers). It is also valid to use both the \"standard\" and the array properties in the same collection."],"MultiSolid (gml:)":["A gml:MultiSolid is defined by one or more gml:AbstractSolids.\nThe members of the geometric aggregate may be specified either using the \"standard\" property (gml:solidMember) or the array property (gml:solidMembers). It is also valid to use both the \"standard\" and the array properties in the same collection."],"MultiSurface (gml:)":["A gml:MultiSurface is defined by one or more gml:AbstractSurfaces.\nThe members of the geometric aggregate may be specified either using the \"standard\" property (gml:surfaceMember) or the array property (gml:surfaceMembers). It is also valid to use both the \"standard\" and the array properties in the same collection."],"curveMembers (gml:)":["This property element contains a list of curves. The order of the elements is significant and shall be preserved when processing the array."],"geometryMember (gml:)":["This property element either references a geometry element via the XLink-attributes or contains the geometry element."],"geometryMembers (gml:)":["This property element contains a list of geometry elements. The order of the elements is significant and shall be preserved when processing the array."],"multiCurveProperty (gml:)":["This property element either references a curve aggregate via the XLink-attributes or contains the \"multi curve\" element. multiCurveProperty is the predefined property, which may be used by GML Application Schemas whenever a GML feature has a property with a value that is substitutable for MultiCurve."],"multiGeometryProperty (gml:)":["This property element either references a geometric aggregate via the XLink-attributes or contains the \"multi geometry\" element. multiGeometryProperty is the predefined property, which may be used by GML Application Schemas whenever a GML feature has a property with a value that is substitutable for AbstractGeometricAggregate."],"multiPointProperty (gml:)":["This property element either references a point aggregate via the XLink-attributes or contains the \"multi point\" element. multiPointProperty is the predefined property, which may be used by GML Application Schemas whenever a GML feature has a property with a value that is substitutable for MultiPoint."],"multiSolidProperty (gml:)":["This property element either references a solid aggregate via the XLink-attributes or contains the \"multi solid\" element. multiSolidProperty is the predefined property, which may be used by GML Application Schemas whenever a GML feature has a property with a value that is substitutable for MultiSolid."],"multiSurfaceProperty (gml:)":["This property element either references a surface aggregate via the XLink-attributes or contains the \"multi surface\" element. multiSurfaceProperty is the predefined property, which may be used by GML Application Schemas whenever a GML feature has a property with a value that is substitutable for MultiSurface."],"pointMember (gml:)":["This property element either references a Point via the XLink-attributes or contains the Point element."],"pointMembers (gml:)":["This property element contains a list of points. The order of the elements is significant and shall be preserved when processing the array."],"solidMember (gml:)":["This property element either references a solid via the XLink-attributes or contains the solid element. A solid element is any element, which is substitutable for gml:AbstractSolid."],"solidMembers (gml:)":["This property element contains a list of solids. The order of the elements is significant and shall be preserved when processing the array."],"surfaceMembers (gml:)":["This property element contains a list of surfaces. The order of the elements is significant and shall be preserved when processing the array."],"AbstractCurve (gml:)":["The AbstractCurve element is the abstract head of the substitution group for all (continuous) curve elements."],"AbstractGeometricPrimitive (gml:)":["The AbstractGeometricPrimitive element is the abstract head of the substitution group for all (pre- and user-defined) geometric primitives."],"AbstractGeometry (gml:)":["The AbstractGeometry element is the abstract head of the substitution group for all geometry elements of GML. This includes pre-defined and user-defined geometry elements. Any geometry element shall be a direct or indirect extension\/restriction of AbstractGeometryType and shall be directly or indirectly in the substitution group of AbstractGeometry."],"Envelope (gml:)":["Envelope defines an extent using a pair of positions defining opposite corners in arbitrary dimensions. The first direct position is the \"lower corner\" (a coordinate position consisting of all the minimal ordinates for each dimension for all points within the envelope), the second one the \"upper corner\" (a coordinate position consisting of all the maximal ordinates for each dimension for all points within the envelope).\nThe use of the properties &#8220;coordinates&#8221; and &#8220;pos&#8221; has been deprecated. The explicitly named properties &#8220;lowerCorner&#8221; and &#8220;upperCorner&#8221; shall be used instead."],"LineString (gml:)":["A LineString is a special curve that consists of a single segment with linear interpolation. It is defined by two or more coordinate tuples, with linear interpolation between them. The number of direct positions in the list shall be at least two."],"Point (gml:)":["A Point is defined by a single coordinate tuple. The direct position of a point is specified by the pos element which is of type DirectPositionType."],"curveArrayProperty (gml:)":["This property element contains a list of curve elements. curveArrayProperty is the predefined property which may be used by GML Application Schemas whenever a GML feature has a property with a value that is substitutable for a list of curves."],"curveProperty (gml:)":["This property element either references a curve via the XLink-attributes or contains the curve element. curveProperty is the predefined property which may be used by GML Application Schemas whenever a GML feature has a property with a value that is substitutable for AbstractCurve."],"pointArrayProperty (gml:)":["This property element contains a list of point elements. pointArrayProperty is the predefined property which may be used by GML Application Schemas whenever a GML feature has a property with a value that is substitutable for a list of points."],"pointProperty (gml:)":["This property element either references a point via the XLink-attributes or contains the point element. pointProperty is the predefined property which may be used by GML Application Schemas whenever a GML feature has a property with a value that is substitutable for Point."],"AbstractRing (gml:)":["An abstraction of a ring to support surface boundaries of different complexity.\nThe AbstractRing element is the abstract head of the substituition group for all closed boundaries of a surface patch."],"AbstractSurface (gml:)":["The AbstractSurface element is the abstract head of the substitution group for all (continuous) surface elements."],"LinearRing (gml:)":["A LinearRing is defined by four or more coordinate tuples, with linear interpolation between them; the first and last coordinates shall be coincident. The number of direct positions in the list shall be at least four."],"Polygon (gml:)":["A Polygon is a special surface that is defined by a single surface patch (see D.3.6). The boundary of this patch is coplanar and the polygon uses planar interpolation in its interior. \nThe elements exterior and interior describe the surface boundary of the polygon."],"exterior (gml:)":["A boundary of a surface consists of a number of rings. In the normal 2D case, one of these rings is distinguished as being the exterior boundary. In a general manifold this is not always possible, in which case all boundaries shall be listed as interior boundaries, and the exterior will be empty."],"interior (gml:)":["A boundary of a surface consists of a number of rings. The \"interior\" rings separate the surface \/ surface patch from the area enclosed by the rings."],"surfaceArrayProperty (gml:)":["This property element contains a list of surface elements. surfaceArrayProperty is the predefined property which may be used by GML Application Schemas whenever a GML feature has a property with a value that is substitutable for a list of AbstractSurfaces."],"surfaceProperty (gml:)":["This property element either references a surface via the XLink-attributes or contains the surface element. surfaceProperty is the predefined property which may be used by GML Application Schemas whenever a GML feature has a property with a value that is substitutable for AbstractSurface."],"CompositeCurve (gml:)":["A gml:CompositeCurve is represented by a sequence of (orientable) curves such that each curve in the sequence terminates at the start point of the subsequent curve in the list. \ncurveMember references or contains inline one curve in the composite curve. \nThe curves are contiguous, the collection of curves is ordered. Therefore, if provided, the aggregationType attribute shall have the value &#8220;sequence&#8221;."],"CompositeSolid (gml:)":["gml:CompositeSolid implements ISO 19107 GM_CompositeSolid (see ISO 19107:2003, 6.6.7) as specified in D.2.3.6. \nA gml:CompositeSolid is represented by a set of orientable surfaces. It is a geometry type with all the geometric properties of a (primitive) solid. Essentially, a composite solid is a collection of solids that join in pairs on common boundary surfaces and which, when considered as a whole, form a single solid. \nsolidMember references or contains one solid in the composite solid. The solids are contiguous."],"CompositeSurface (gml:)":["A gml:CompositeSurface is represented by a set of orientable surfaces. It is geometry type with all the geometric properties of a (primitive) surface. Essentially, a composite surface is a collection of surfaces that join in pairs on common boundary curves and which, when considered as a whole, form a single surface.\nsurfaceMember references or contains inline one surface in the composite surface. \nThe surfaces are contiguous."],"AbstractCurveSegment (gml:)":["A curve segment defines a homogeneous segment of a curve.\nThe attributes numDerivativesAtStart, numDerivativesAtEnd and numDerivativesInterior specify the type of continuity as specified in ISO 19107:2003, 6.4.9.3.\nThe AbstractCurveSegment element is the abstract head of the substituition group for all curve segment elements, i.e. continuous segments of the same interpolation mechanism.\nAll curve segments shall have an attribute interpolation with type gml:CurveInterpolationType specifying the curve interpolation mechanism used for this segment. This mechanism uses the control points and control parameters to determine the position of this curve segment."],"AbstractGriddedSurface (gml:)":["if provided, rows gives the number of rows, columns the number of columns in the parameter grid. The parameter grid is represented by an instance of the gml:PointGrid group.\nThe element provides a substitution group head for the surface patches based on a grid. All derived subtypes shall conform to the constraints specified in ISO 19107:2003, 6.4.41."],"AbstractParametricCurveSurface (gml:)":["The element provides a substitution group head for the surface patches based on parametric curves. All properties are specified in the derived subtypes. All derived subtypes shall conform to the constraints specified in ISO 19107:2003, 6.4.40.\nIf provided, the aggregationType attribute shall have the value &#8220;set&#8221;."],"AbstractSolid (gml:)":["The AbstractSolid element is the abstract head of the substituition group for all (continuous) solid elements."],"AbstractSurfacePatch (gml:)":["A surface patch defines a homogenuous portion of a surface. \nThe AbstractSurfacePatch element is the abstract head of the substituition group for all surface patch elements describing a continuous portion of a surface.\nAll surface patches shall have an attribute interpolation (declared in the types derived from gml:AbstractSurfacePatchType) specifying the interpolation mechanism used for the patch using gml:SurfaceInterpolationType."],"AffinePlacement (gml:)":["location, refDirection, inDimension and outDimension have the same meaning as specified in ISO 19107:2003, 6.4.21."],"Arc (gml:)":["An Arc is an arc string with only one arc unit, i.e. three control points including the start and end point. As arc is an arc string consisting of a single arc, the attribute &#8220;numArc&#8221; is fixed to \"1\"."],"ArcByBulge (gml:)":["An ArcByBulge is an arc string with only one arc unit, i.e. two control points, one bulge and one normal vector.\nAs arc is an arc string consisting of a single arc, the attribute &#8220;numArc&#8221; is fixed to \"1\"."],"ArcByCenterPoint (gml:)":["This variant of the arc requires that the points on the arc shall be computed instead of storing the coordinates directly. The single control point is the center point of the arc plus the radius and the bearing at start and end. This representation can be used only in 2D.\nThe element radius specifies the radius of the arc.\nThe element startAngle specifies the bearing of the arc at the start.\nThe element endAngle specifies the bearing of the arc at the end.\nThe interpolation is fixed as \"circularArcCenterPointWithRadius\".\nSince this type describes always a single arc, the attribute &#8220;numArc&#8221; is fixed to \"1\".\nThe content model follows the general pattern for the encoding of curve segments."],"ArcString (gml:)":["An ArcString is a curve segment that uses three-point circular arc interpolation (&#8220;circularArc3Points&#8221;). The number of arcs in the arc string may be explicitly stated in the attribute numArc. The number of control points in the arc string shall be 2 * numArc + 1.\nThe content model follows the general pattern for the encoding of curve segments."],"ArcStringByBulge (gml:)":["This variant of the arc computes the mid points of the arcs instead of storing the coordinates directly. The control point sequence consists of the start and end points of each arc plus the bulge (see ISO 19107:2003, 6.4.17.2). The normal is a vector normal (perpendicular) to the chord of the arc (see ISO 19107:2003, 6.4.17.4).\nThe interpolation is fixed as \"circularArc2PointWithBulge\".\nThe number of arcs in the arc string may be explicitly stated in the attribute numArc. The number of control points in the arc string shall be numArc + 1.\nThe content model follows the general pattern for the encoding of curve segments."],"BSpline (gml:)":["A B-Spline is a piecewise parametric polynomial or rational curve described in terms of control points and basis functions as specified in ISO 19107:2003, 6.4.30. Therefore, interpolation may be either \"polynomialSpline\" or \"rationalSpline\" depending on the interpolation type; default is \"polynomialSpline\".\ndegree shall be the degree of the polynomial used for interpolation in this spline.\nknot shall be the sequence of distinct knots used to define the spline basis functions (see ISO 19107:2003, 6.4.26.2).\nThe attribute isPolynomial shall be set to &#8220;true&#8221; if this is a polynomial spline (see ISO 19107:2003, 6.4.30.5).\nThe attribute knotType shall provide the type of knot distribution used in defining this spline (see ISO 19107:2003, 6.4.30.4).\nThe content model follows the general pattern for the encoding of curve segments."],"Bezier (gml:)":["Bezier curves are polynomial splines that use Bezier or Bernstein polynomials for interpolation purposes. It is a special case of the B-Spline curve with two knots.\ndegree shall be the degree of the polynomial used for interpolation in this spline.\nknot shall be the sequence of distinct knots used to define the spline basis functions.\ninterpolation is fixed as \"polynomialSpline\".\nisPolynomial is fixed as &#8220;true&#8221;.\nknotType is not relevant for Bezier curve segments.\n"],"Circle (gml:)":["A Circle is an arc whose ends coincide to form a simple closed loop. The three control points shall be distinct non-co-linear points for the circle to be unambiguously defined. The arc is simply extended past the third control point until the first control point is encountered."],"CircleByCenterPoint (gml:)":["A gml:CircleByCenterPoint is an gml:ArcByCenterPoint with identical start and end angle to form a full circle. Again, this representation can be used only in 2D."],"Clothoid (gml:)":["A clothoid, or Cornu's spiral, is plane curve whose curvature is a fixed function of its length.\nrefLocation, startParameter, endParameter and scaleFactor have the same meaning as specified in ISO 19107:2003, 6.4.22.\ninterpolation is fixed as \"clothoid\".\nThe content model follows the general pattern for the encoding of curve segments."],"CubicSpline (gml:)":["The number of control points shall be at least three.\nvectorAtStart is the unit tangent vector at the start point of the spline. vectorAtEnd is the unit tangent vector at the end point of the spline. Only the direction of the vectors shall be used to determine the shape of the cubic spline, not their length.\ninterpolation is fixed as \"cubicSpline\".\ndegree shall be the degree of the polynomial used for the interpolation in this spline. Therefore the degree for a cubic spline is fixed to \"3\".\nThe content model follows the general pattern for the encoding of curve segments."],"Curve (gml:)":["A curve is a 1-dimensional primitive. Curves are continuous, connected, and have a measurable length in terms of the coordinate system. \nA curve is composed of one or more curve segments. Each curve segment within a curve may be defined using a different interpolation method. The curve segments are connected to one another, with the end point of each segment except the last being the start point of the next segment in the segment list.\nThe orientation of the curve is positive.\nThe element segments encapsulates the segments of the curve."],"GeodesicString (gml:)":["A sequence of geodesic segments. \nThe number of control points shall be at least two.\ninterpolation is fixed as \"geodesic\".\nThe content model follows the general pattern for the encoding of curve segments."],"LineStringSegment (gml:)":["A LineStringSegment is a curve segment that is defined by two or more control points including the start and end point, with linear interpolation between them.\nThe content model follows the general pattern for the encoding of curve segments."],"OffsetCurve (gml:)":["An offset curve is a curve at a constant distance from the basis curve. offsetBase is the base curve from which this curve is defined as an offset. distance and refDirection have the same meaning as specified in ISO 19107:2003, 6.4.23.\nThe content model follows the general pattern for the encoding of curve segments."],"OrientableCurve (gml:)":["OrientableCurve consists of a curve and an orientation. If the orientation is \"+\", then the OrientableCurve is identical to the baseCurve. If the orientation is \"-\", then the OrientableCurve is related to another AbstractCurve with a parameterization that reverses the sense of the curve traversal."],"OrientableSurface (gml:)":["OrientableSurface consists of a surface and an orientation. If the orientation is \"+\", then the OrientableSurface is identical to the baseSurface. If the orientation is \"-\", then the OrientableSurface is a reference to a gml:AbstractSurface with an up-normal that reverses the direction for this OrientableSurface, the sense of \"the top of the surface\"."],"PolygonPatch (gml:)":["A gml:PolygonPatch is a surface patch that is defined by a set of boundary curves and an underlying surface to which these curves adhere. The curves shall be coplanar and the polygon uses planar interpolation in its interior. \ninterpolation is fixed to \"planar\", i.e. an interpolation shall return points on a single plane. The boundary of the patch shall be contained within that plane."],"PolyhedralSurface (gml:)":["A polyhedral surface is a surface composed of polygon patches connected along their common boundary curves. This differs from the surface type only in the restriction on the types of surface patches acceptable.\npolygonPatches encapsulates the polygon patches of the polyhedral surface."],"Rectangle (gml:)":["gml:Rectangle represents a rectangle as a surface patch with an outer boundary consisting of a linear ring. Note that this is a polygon (subtype) with no inner boundaries. The number of points in the linear ring shall be five.\nThe ring (element exterior) shall be a gml:LinearRing and shall form a rectangle; the first and the last position shall be coincident.\ninterpolation is fixed to \"planar\", i.e. an interpolation shall return points on a single plane. The boundary of the patch shall be contained within that plane."],"Ring (gml:)":["A ring is used to represent a single connected component of a surface boundary as specified in ISO 19107:2003, 6.3.6.\nEvery gml:curveMember references or contains one curve, i.e. any element which is substitutable for gml:AbstractCurve. In the context of a ring, the curves describe the boundary of the surface. The sequence of curves shall be contiguous and connected in a cycle.\nIf provided, the aggregationType attribute shall have the value &#8220;sequence&#8221;."],"Shell (gml:)":["A shell is used to represent a single connected component of a solid boundary as specified in ISO 19107:2003, 6.3.8.\nEvery gml:surfaceMember references or contains one surface, i.e. any element which is substitutable for gml:AbstractSurface. In the context of a shell, the surfaces describe the boundary of the solid. \nIf provided, the aggregationType attribute shall have the value &#8220;set&#8221;.\n"],"Solid (gml:)":["A solid is the basis for 3-dimensional geometry. The extent of a solid is defined by the boundary surfaces as specified in ISO 19107:2003, 6.3.18. exterior specifies the outer boundary, interior the inner boundary of the solid."],"Surface (gml:)":["A Surface is a 2-dimensional primitive and is composed of one or more surface patches as specified in ISO 19107:2003, 6.3.17.1. The surface patches are connected to one another.\npatches encapsulates the patches of the surface."],"Tin (gml:)":["A tin is a triangulated surface that uses the Delauny algorithm or a similar algorithm complemented with consideration of stoplines (stopLines), breaklines (breakLines), and maximum length of triangle sides (maxLength). controlPoint shall contain a set of the positions (three or more) used as posts for this TIN (corners of the triangles in the TIN). See ISO 19107:2003, 6.4.39 for details."],"Triangle (gml:)":["gml:Triangle represents a triangle as a surface patch with an outer boundary consisting of a linear ring. Note that this is a polygon (subtype) with no inner boundaries. The number of points in the linear ring shall be four.\nThe ring (element exterior) shall be a gml:LinearRing and shall form a triangle, the first and the last position shall be coincident.\ninterpolation is fixed to \"planar\", i.e. an interpolation shall return points on a single plane. The boundary of the patch shall be contained within that plane."],"TriangulatedSurface (gml:)":["A triangulated surface is a polyhedral surface that is composed only of triangles. There is no restriction on how the triangulation is derived.\ntrianglePatches encapsulates the triangles of the triangulated surface."],"baseCurve (gml:)":["The property baseCurve references or contains the base curve, i.e. it either references the base curve via the XLink-attributes or contains the curve element. A curve element is any element which is substitutable for AbstractCurve. The base curve has positive orientation."],"baseSurface (gml:)":["The property baseSurface references or contains the base surface. The property baseSurface either references the base surface via the XLink-attributes or contains the surface element. A surface element is any element which is substitutable for gml:AbstractSurface. The base surface has positive orientation."],"patches (gml:)":["The patches property element contains the sequence of surface patches. The order of the elements is significant and shall be preserved when processing the array."],"segments (gml:)":["This property element contains a list of curve segments. The order of the elements is significant and shall be preserved when processing the array."],"solidArrayProperty (gml:)":["This property element contains a list of solid elements. solidArrayProperty is the predefined property which may be used by GML Application Schemas whenever a GML feature has a property with a value that is substitutable for a list of AbstractSolid."],"solidProperty (gml:)":["This property element either references a solid via the XLink-attributes or contains the solid element. solidProperty is the predefined property which may be used by GML Application Schemas whenever a GML feature has a property with a value that is substitutable for AbstractSolid."],"surfaceMember (gml:)":["This property element either references a surface via the XLink-attributes or contains the surface element. A surface element is any element, which is substitutable for gml:AbstractSurface."],"AbstractGML (gml:)":["The abstract element gml:AbstractGML is &#8220;any GML object having identity&#8221;.   It acts as the head of an XML Schema substitution group, which may include any element which is a GML feature, or other object, with identity.  This is used as a variable in content models in GML core and application schemas.  It is effectively an abstract superclass for all GML objects."],"AbstractObject (gml:)":["This element has no type defined, and is therefore implicitly (according to the rules of W3C XML Schema) an XML Schema anyType. It is used as the head of an XML Schema substitution group which unifies complex content and certain simple content elements used for datatypes in GML, including the gml:AbstractGML substitution group."],"abstractAssociationRole (gml:)":["Applying this pattern shall restrict the multiplicity of objects in a property element using this content model to exactly one. An instance of this type shall contain an element representing an object, or serve as a pointer to a remote object.\nApplying the pattern to define an application schema specific property type allows to restrict\n-\tthe inline object to specified object types, \n-\tthe encoding to &#8222;by-reference only&#8220; (see 7.2.3.7),\n-\tthe encoding to &#8222;inline only&#8220; (see 7.2.3.8)."],"abstractInlineProperty (gml:)":["gml:abstractInlineProperty may be used as the head of a subtitution group of more specific elements providing a value inline."],"abstractReference (gml:)":["gml:abstractReference may be used as the head of a subtitution group of more specific elements providing a value by-reference."],"abstractStrictAssociationRole (gml:)":["This element shows how an element \n\tdeclaration may include a Schematron constraint to limit the property to act \n\tin either inline or by-reference mode, but not both."],"description (gml:)":["The value of this property is a text description of the object. gml:description uses gml:StringOrRefType as its content model, so it may contain a simple text string content, or carry a reference to an external description. The use of gml:description to reference an external description has been deprecated and replaced by the gml:descriptionReference property."],"descriptionReference (gml:)":["The value of this property is a remote text description of the object. The xlink:href attribute of the gml:descriptionReference property references the external description."],"identifier (gml:)":["Often, a special identifier is assigned to an object by the maintaining authority with the intention that it is used in references to the object For such cases, the codeSpace shall be provided. That identifier is usually unique either globally or within an application domain. gml:identifier is a pre-defined property for such identifiers."],"name (gml:)":["The gml:name property provides a label or identifier for the object, commonly a descriptive name. An object may have several names, typically assigned by different authorities. gml:name uses the gml:CodeType content model.  The authority for a name is indicated by the value of its (optional) codeSpace attribute.  The name may or may not be unique, as determined by the rules of the organization responsible for the codeSpace.  In common usage there will be one name per authority, so a processing application may select the name from its preferred codeSpace."],"reversePropertyName (gml:)":["If the value of an object property is another object and that object contains also a property for the association between the two objects, then this name of the reverse property may be encoded in a gml:reversePropertyName element in an appinfo annotation of the property element to document the constraint between the two properties. The value of the element shall contain the qualified name of the property element."],"Grid (gml:)":["The gml:Grid implicitly defines an unrectified grid, which is a network composed of two or more sets of curves in which the members of each set intersect the members of the other sets in an algorithmic way.  The region of interest within the grid is given in terms of its gml:limits, being the grid coordinates of  diagonally opposed corners of a rectangular region.  gml:axisLabels is provided with a list of labels of the axes of the grid (gml:axisName has been deprecated). gml:dimension specifies the dimension of the grid.  \nThe gml:limits element contains a single gml:GridEnvelope. The gml:low and gml:high property elements of the envelope are each integerLists, which are coordinate tuples, the coordinates being measured as offsets from the origin of the grid along each axis, of the diagonally opposing corners of a &#8220;rectangular&#8221; region of interest."],"RectifiedGrid (gml:)":["A rectified grid is a grid for which there is an affine transformation between the grid coordinates and the coordinates of an external coordinate reference system. It is defined by specifying the position (in some geometric space) of the grid &#8220;origin&#8221; and of the vectors that specify the post locations.\nNote that the grid limits (post indexes) and axis name properties are inherited from gml:GridType and that gml:RectifiedGrid adds a gml:origin property (contains or references a gml:Point) and a set of gml:offsetVector properties."],"angle (gml:)":["The gml:angle property element is used to record the value of an angle quantity as a single number, with its units."],"measure (gml:)":["The value of a physical quantity, together with its unit."],"DirectedObservation (gml:)":["A gml:DirectedObservation is the same as an observation except that it adds an additional gml:direction property. This is the direction in which the observation was acquired. Clearly this applies only to certain types of observations such as visual observations by people, or observations obtained from terrestrial cameras."],"DirectedObservationAtDistance (gml:)":["gml:DirectedObservationAtDistance adds an additional distance property. This is the distance from the observer to the subject of the observation. Clearly this applies only to certain types of observations such as visual observations by people, or observations obtained from terrestrial cameras."],"Observation (gml:)":["The content model is a straightforward extension of gml:AbstractFeatureType; it automatically has the gml:identifier, gml:description, gml:descriptionReference, gml:name, and gml:boundedBy properties. \nThe gml:validTime element describes the time of the observation. Note that this may be a time instant or a time period.\nThe gml:using property contains or references a description of a sensor, instrument or procedure used for the observation.\nThe gml:target property contains or references the specimen, region or station which is the object of the observation. This property is particularly useful for remote observations, such as photographs, where a generic location property might apply to the location of the camera or the location of the field of view, and thus may be ambiguous.  \nThe gml:subject element is provided as a convenient synonym for gml:target. This is the term commonly used in phtotography.  \nThe gml:resultOf property indicates the result of the observation.  The value may be inline, or a reference to a value elsewhere. If the value is inline, it shall be a member of the gml:AbstractObject substitution group.\n"],"AbstractCRS (gml:)":["gml:AbstractCRS specifies a coordinate reference system which is usually single but may be compound. This abstract complex type shall not be used, extended, or restricted, in a GML Application Schema, to define a concrete subtype with a meaning equivalent to a concrete subtype specified in this document."],"crsRef (gml:)":["gml:crsRef is an association role either referencing or containing the definition of a CRS. This property element has been deprecated."],"domainOfValidity (gml:)":["The gml:domainOfValidity property implements an association role to an EX_Extent object as encoded in ISO\/TS 19139, either referencing or containing the definition of that extent."],"scope (gml:)":["The gml:scope property provides a description of the usage, or limitations of usage, for which this CRS-related object is valid. If unknown, enter \"not known\"."],"AbstractTimeComplex (gml:)":["gml:AbstractTimeComplex is an aggregation of temporal primitives and acts as the head of a substitution group for temporal complexes."],"AbstractTimeGeometricPrimitive (gml:)":["gml:TimeGeometricPrimitive acts as the head of a substitution group for geometric temporal primitives.\nA temporal geometry shall be associated with a temporal reference system through the frame attribute that provides a URI reference that identifies a description of the reference system. Following ISO 19108, the Gregorian calendar with UTC is the default reference system, but others may also be used. The GPS calendar is an alternative reference systems in common use.\nThe two geometric primitives in the temporal dimension are the instant and the period. GML components are defined to support these as follows."],"AbstractTimeObject (gml:)":["gml:AbstractTimeObject acts as the head of a substitution group for all temporal primitives and complexes."],"AbstractTimePrimitive (gml:)":["gml:AbstractTimePrimitive acts as the head of a substitution group for geometric and topological temporal primitives."],"TimeInstant (gml:)":["gml:TimeInstant acts as a zero-dimensional geometric primitive that represents an identifiable position in time."],"TimePeriod (gml:)":["gml:TimePeriod acts as a one-dimensional geometric primitive that represents an identifiable extent in time.\nThe location in of a gml:TimePeriod is described by the temporal positions of the instants at which it begins and ends. The length of the period is equal to the temporal distance between the two bounding temporal positions. \nBoth beginning and end may be described in terms of their direct position using gml:TimePositionType which is an XML Schema simple content type, or by reference to an indentifiable time instant using gml:TimeInstantPropertyType.\nAlternatively a limit of a gml:TimePeriod may use the conventional GML property model to make a reference to a time instant described elsewhere, or a limit may be indicated as a direct position."],"duration (gml:)":["gml:duration conforms to the ISO 8601 syntax for temporal length as implemented by the XML Schema duration type."],"timeInterval (gml:)":[" gml:timeInterval conforms to ISO 11404 which is based on floating point values for temporal length.\nISO 11404 syntax specifies the use of a positiveInteger together with appropriate values for radix and factor. The resolution of the time interval is to one radix ^(-factor) of the specified time unit.\nThe value of the unit is either selected from the units for time intervals from ISO 31-1:1992, or is another suitable unit.  The encoding is defined for GML in gml:TimeUnitType. The second component of this union type provides a method for indicating time units other than the six standard units given in the enumeration."],"timePosition (gml:)":["This element is used directly as a property of gml:TimeInstant (see 15.2.2.3), and may also be used in application schemas."],"validTime (gml:)":["gml:validTime is a convenience property element."],"TimeCalendar (gml:)":["A calendar is a discrete temporal reference system that provides a basis for defining temporal position to a resolution of one day.\ngml:TimeCalendar adds one property to those inherited from gml:TimeReferenceSystem. A gml:referenceFrame provides a link to a gml:TimeCalendarEra that it uses. A  gml:TimeCalendar may reference more than one calendar era. \nThe referenceFrame element follows the standard GML property model, allowing the association to be instantiated either using an inline description using the gml:TimeCalendarEra element, or a link to a gml:TimeCalendarEra which is explicit elsewhere."],"TimeCalendarEra (gml:)":["gml:TimeCalendarEra inherits basic properties from gml:DefinitionType and has the following additional properties:\n-\tgml:referenceEvent is the name or description of a mythical or historic event which fixes the position of the base scale of the calendar era.  This is given as text or using a link to description held elsewhere.\n-\tgml:referenceDate specifies the date of the referenceEvent expressed as a date in the given calendar.  In most calendars, this date is the origin (i.e., the first day) of the scale, but this is not always true.\n-\tgml:julianReference specifies the Julian date that corresponds to the reference date.  The Julian day number is an integer value; the Julian date is a decimal value that allows greater resolution.  Transforming calendar dates to and from Julian dates provides a relatively simple basis for transforming dates from one calendar to another.\n-\tgml:epochOfUse is the period for which the calendar era was used as a basis for dating."],"TimeClock (gml:)":["A clock provides a basis for defining temporal position within a day. A clock shall be used with a calendar in order to provide a complete description of a temporal position within a specific day.\ngml:TimeClock adds the following properties to those inherited from gml:TimeReferenceSystemType:\n-\tgml:referenceEvent is the name or description of an event, such as solar noon or sunrise, which fixes the position of the base scale of the clock.\n-\tgml:referenceTime specifies the time of day associated with the reference event expressed as a time of day in the given clock. The reference time is usually the origin of the clock scale. \n-\tgml:utcReference specifies the 24 hour local or UTC time that corresponds to the reference time.\n-\tgml:dateBasis contains or references the calendars that use this clock."],"TimeCoordinateSystem (gml:)":["A temporal coordinate system shall be based on a continuous interval scale defined in terms of a single time interval.\nThe differences to ISO 19108 TM_CoordinateSystem are:\n-\tthe origin is specified either using the property gml:originPosition whose value is a direct time position, or using the property gml:origin whose model is gml:TimeInstantPropertyType; this permits more flexibility in representation and also supports referring to a value fixed elsewhere;\n-\tthe interval uses gml:TimeIntervalLengthType.\n"],"TimeOrdinalEra (gml:)":["Its content model follows the pattern of gml:TimeEdge, inheriting standard properties from gml:DefinitionType, and adding gml:start, gml:end and gml:extent properties, a set of gml:member properties which indicate ordered gml:TimeOrdinalEra elements, and a gml:group property which points to the parent era.\nThe recursive inclusion of gml:TimeOrdinalEra elements allow the construction of an arbitrary depth hierarchical ordinal reference schema, such that an ordinal era at a given level of the hierarchy includes a sequence of shorter, coterminous ordinal eras."],"TimeOrdinalReferenceSystem (gml:)":["In some applications of geographic information &#8212; such as geology and archaeology &#8212; relative position in time is known more precisely than absolute time or duration. The order of events in time can be well established, but the magnitude of the intervals between them cannot be accurately determined; in such cases, the use of an ordinal temporal reference system is appropriate. An ordinal temporal reference system is composed of a sequence of named coterminous eras, which may in turn be composed of sequences of member eras at a finer scale, giving the whole a hierarchical structure of eras of verying resolution. \nAn ordinal temporal reference system whose component eras are not further subdivided is effectively a temporal topological complex constrained to be a linear graph. An ordinal temporal reference system some or all of whose component eras are subdivided is effectively a temporal topological complex with the constraint that parallel branches may only be constructed in pairs where one is a single temporal ordinal era and the other is a sequence of temporal ordinal eras that are called \"members\" of the \"group\". This constraint means that within a single temporal ordinal reference system, the relative position of all temporal ordinal eras is unambiguous.  \nThe positions of the beginning and end of a given era may calibrate the relative time scale.\ngml:TimeOrdinalReferenceSystem adds one or more gml:component properties to the generic temporal reference system model."],"TimeReferenceSystem (gml:)":["A reference system is characterized in terms of its domain of validity: the spatial and temporal extent over which it is applicable. The basic GML element for temporal reference systems is gml:TimeReferenceSystem.  Its content model extends gml:DefinitionType with one additional property, gml:domainOfValidity."],"AbstractTimeTopologyPrimitive (gml:)":["gml:TimeTopologyPrimitive acts as the head of a substitution group for topological temporal primitives.\nTemporal topology primitives shall imply the ordering information between features or feature properties. The temporal connection of features can be examined if they have temporal topology primitives as values of their properties. Usually, an instantaneous feature associates with a time node, and a static feature associates with a time edge.  A feature with both modes associates with the temporal topology primitive: a supertype of time nodes and time edges.\nA topological primitive is always connected to one or more other topological primitives, and is, therefore, always a member of a topological complex. In a GML instance, this will often be indicated by the primitives being described by elements that are descendents of an element describing a complex. However, in order to support the case where a temporal topological primitive is described in another context, the optional complex property is provided, which carries a reference to the parent temporal topological complex."],"TimeEdge (gml:)":["A time edge is a one-dimensional topological primitive. It is an open interval that starts and ends at a node. The edge may be realised as a geometry whose value is a time period."],"TimeNode (gml:)":["A time node is a zero-dimensional topological primitive that represents an identifiable node in time (it is equivalent to a point in space). A node may act as the termination or initiation of any number of time edges. A time node may be realised as a geometry, its position, whose value is a time instant."],"TimeTopologyComplex (gml:)":["A temporal topology complex shall be the connected acyclic directed graph composed of temporal topological primitives, i.e. time nodes and time edges. Because a time edge may not exist without two time nodes on its boundaries, static features have time edges from a temporal topology complex as the values of their temporal properties, regardless of explicit declarations.\nA temporal topology complex expresses a linear or a non-linear graph. A temporal linear graph, composed of a sequence of time edges, provides a lineage described only by &#8220;substitution&#8221; of feature instances or feature element values. A time node as the start or the end of the graph connects with at least one time edge. A time node other than the start and the end shall connect to at least two time edges: one of starting from the node, and another ending at the node.\nA temporal topological complex is a set of connected temporal topological primitives. The member primtives are indicated, either by reference or by value, using the primitive property."],"AbstractTopoPrimitive (gml:)":["gml:AbstractTopoPrimitive acts as the base type for all topological primitives. Topology primitives are the atomic (smallest possible) units of a topology complex. \nEach topology primitive may contain references to other topology primitives of codimension 2 or more (gml:isolated). Conversely, nodes may have faces as containers and nodes and edges may have solids as containers (gml:container)."],"Edge (gml:)":["gml:Edge represents the 1-dimensional primitive.\nThe topological boundary of an Edge (gml:directedNode) consists of a negatively directed start Node and a positively directed end Node.   \nThe optional coboundary of an edge (gml:directedFace) is a circular sequence of directed faces which are incident on this edge in document order. In the 2D case, the orientation of the face on the left of the edge is \"+\"; the orientation of the face on the right on its right is \"-\". \nIf provided, the aggregationType attribute shall have the value &#8220;sequence&#8221;.\nAn edge may optionally be realised by a 1-dimensional geometric primitive (gml:curveProperty)."],"Face (gml:)":["gml:Face represents the 2-dimensional topology primitive.\nThe topological boundary of a face (gml:directedEdge) consists of a sequence of directed edges. If provided, the aggregationType attribute shall have the value &#8220;sequence&#8221;.\nThe optional coboundary of a face (gml:directedTopoSolid) is a pair of directed solids which are bounded by this face. A positively directed solid corresponds to a solid which lies in the direction of the negatively directed normal to the face in any geometric realisation. \nA face may optionally be realised by a 2-dimensional geometric primitive (gml:surfaceProperty)."],"Node (gml:)":["gml:Node represents the 0-dimensional primitive.\nThe optional coboundary of a node (gml:directedEdge) is a sequence of directed edges which are incident on this node. Edges emanating from this node appear in the node coboundary with a negative orientation. \nIf provided, the aggregationType attribute shall have the value &#8220;sequence&#8221;.\nA node may optionally be realised by a 0-dimensional geometric primitive (gml:pointProperty)."],"TopoComplex (gml:)":["gml:TopoComplex is a collection of topological primitives.\nEach complex holds a reference to its maximal complex (gml:maximalComplex) and optionally to sub- or super-complexes (gml:subComplex, gml:superComplex). \nA topology complex contains its primitive and sub-complex members.\n"],"TopoCurve (gml:)":["gml:TopoCurve represents a homogeneous topological expression, a sequence of directed edges, which if realised are isomorphic to a geometric curve primitive. The intended use of gml:TopoCurve is to appear within a line feature to express the structural and geometric relationships of this feature to other features via the shared edge definitions.\nIf provided, the aggregationType attribute shall have the value &#8220;sequence&#8221;."],"TopoPoint (gml:)":["The intended use of gml:TopoPoint is to appear within a point feature to express the structural and possibly geometric relationships of this feature to other features via shared node definitions."],"TopoSolid (gml:)":["gml:TopoSolid represents the 3-dimensional topology primitive. \nThe topological boundary of a solid (gml:directedFace) consists of a set of directed faces.\nA solid may optionally be realised by a 3-dimensional geometric primitive (gml:solidProperty)."],"TopoSurface (gml:)":["gml:TopoSurface represents a homogeneous topological expression, a set of directed faces, which if realised are isomorphic to a geometric surface primitive. The intended use of gml:TopoSurface is to appear within a surface feature to express the structural and possibly geometric relationships of this surface feature to other features via the shared face definitions."],"TopoVolume (gml:)":["gml:TopoVolume represents a homogeneous topological expression, a set of directed topologic solids, which if realised are isomorphic to a geometric solid primitive. The intended use of gml:TopoVolume is to appear within a solid feature to express the structural and geometric relationships of this solid feature to other features via the shared solid definitions."],"container (gml:)":["The gml:container property element implements the role of the same name of the ISO 19107 &#8220;Isolated In&#8221; association (see ISO 19107:2003, 7.3.10.4)."],"directedEdge (gml:)":["A gml:directedEdge property element describes the boundary of topology faces, the coBoundary of topology nodes and is used in the support of topological line features via the gml:TopoCurve expression, see below. The orientation attribute of type gml:SignType expresses the sense in which the included edge is used, i.e. forward or reverse."],"directedFace (gml:)":["The gml:directedFace property element describes the boundary of topology solids, in the coBoundary of topology edges and is used in the support of surface features via the gml:TopoSurface expression, see below. The orientation attribute of type gml:SignType expresses the sense in which the included face is used i.e. inward or outward with respect to the surface normal in any geometric realisation."],"directedNode (gml:)":["A gml:directedNode property element describes the boundary of topology edges and is used in the support of topological point features via the gml:TopoPoint expression, see below. The orientation attribute of type gml:SignType expresses the sense in which the included node is used: start (&#8220;-&#8220;) or end (&#8220;+&#8221;) node."],"directedTopoSolid (gml:)":["The gml:directedSolid property element describes the coBoundary of topology faces and is used in the support of volume features via the gml:TopoVolume expression, see below. The orientation attribute of type gml:SignType expresses the sense in which the included solid appears in the face coboundary. In the context of a gml:TopoVolume the orientation attribute has no meaning."],"isolated (gml:)":["The gml:isolated property element implements the role of the same name of the ISO 19107 &#8220;Isolated In&#8221; association (see ISO 19107:2003, 7.3.10.4)."],"maximalComplex (gml:)":["The property elements gml:subComplex, gml:superComplex and gml:maximalComplex provide an encoding for relationships between topology complexes as described for gml:TopoComplex above."],"subComplex (gml:)":["The property elements gml:subComplex, gml:superComplex and gml:maximalComplex provide an encoding for relationships between topology complexes as described for gml:TopoComplex above."],"superComplex (gml:)":["The property elements gml:subComplex, gml:superComplex and gml:maximalComplex provide an encoding for relationships between topology complexes as described for gml:TopoComplex above."],"topoComplexProperty (gml:)":["The gml:topoComplexProperty property element encodes the relationship between a GML object and a topological complex."],"topoCurveProperty (gml:)":["The gml:topoCurveProperty property element may be used in features to express their relationship to the referenced topology edges."],"topoPointProperty (gml:)":["The gml:topoPointProperty property element may be used in features to express their relationship to the referenced topology node."],"topoPrimitiveMember (gml:)":["The gml:topoPrimitiveMember property element encodes for the relationship between a topology complex and a single topology primitive."],"topoPrimitiveMembers (gml:)":["The gml:topoPrimitiveMembers property element encodes the relationship between a topology complex and an arbitrary number of topology primitives."],"topoSurfaceProperty (gml:)":["The gml:topoSurfaceProperty property element may be used in features to express their relationship to the referenced topology faces."],"topoVolumeProperty (gml:)":["The gml:topoVolumeProperty element may be used in features to express their relationship to the referenced topology volume."],"BaseUnit (gml:)":["A base unit is a unit of measure that cannot be derived by combination of other base units within a particular system of units.  For example, in the SI system of units, the base units are metre, kilogram, second, Ampere, Kelvin, mole, and candela, for the physical quantity types length, mass, time interval, electric current, thermodynamic temperature, amount of substance and luminous intensity, respectively.\ngml:BaseUnit extends generic gml:UnitDefinition with the property gml:unitsSystem, which carries a reference to the units system to which this base unit is asserted to belong.  "],"ConventionalUnit (gml:)":["Conventional units that are neither base units nor defined by direct combination of base units are used in many application domains.  For example electronVolt for energy, feet and nautical miles for length.  In most cases there is a known, usually linear, conversion to a preferred unit which is either a base unit or derived by direct combination of base units.\nThe gml:ConventionalUnit extends gml:UnitDefinition with a property that describes a conversion to a preferred unit for this physical quantity.  When the conversion is exact, the element gml:conversionToPreferredUnit should be used, or when the conversion is not exact the element gml:roughConversionToPreferredUnit is available. Both of these elements have the same content model.  The gml:derivationUnitTerm property defined above is included to allow a user to optionally record how this unit may be derived from other (&#8220;more primitive&#8221;) units."],"DerivedUnit (gml:)":["Derived units are defined by combination of other units.  Derived units are used for quantities other than those corresponding to the base units, such as hertz (s-1) for frequency, Newton (kg.m\/s2) for force.  Derived units based directly on base units are usually preferred for quantities other than the fundamental quantities within a system. If a derived unit is not the preferred unit, the gml:ConventionalUnit element should be used instead.\nThe gml:DerivedUnit extends gml:UnitDefinition with the property gml:derivationUnitTerms."],"UnitDefinition (gml:)":["A gml:UnitDefinition is a general definition of a unit of measure. This generic element is used only for units for which no relationship with other units or units systems is known.\nThe content model of gml:UnitDefinition adds three additional properties to gml:Definition, gml:quantityType, gml:quantityTypeReference and gml:catalogSymbol.  \nThe gml:catalogSymbol property optionally gives the short symbol used for this unit. This element is usually used when the relationship of this unit to other units or units systems is unknown."],"catalogSymbol (gml:)":["The catalogSymbol is the preferred lexical symbol used for this unit of measure.\nThe codeSpace attribute in gml:CodeType identifies a namespace for the catalog symbol value, and might reference the external catalog. The string value in gml:CodeType contains the value of a symbol that should be unique within this catalog namespace. This symbol often appears explicitly in the catalog, but it could be a combination of symbols using a specified algebra of units."],"conversionToPreferredUnit (gml:)":["The elements gml:conversionToPreferredUnit and gml:roughConversionToPreferredUnit represent parameters used to convert conventional units to preferred units for this physical quantity type.  A preferred unit is either a Base Unit or a Derived Unit that is selected for all values of one physical quantity type."],"derivationUnitTerm (gml:)":["A set of gml:derivationUnitTerm elements describes a derived unit of measure.  Each element carries an integer exponent.  The terms are combined by raising each referenced unit to the power of its exponent and forming the product.\nThis unit term references another unit of measure (uom) and provides an integer exponent applied to that unit in defining the compound unit. The exponent may be positive or negative, but not zero."],"quantityType (gml:)":["The gml:quantityType property indicates the phenomenon to which the units apply. This element contains an informal description of the phenomenon or type of physical quantity that is measured or observed. When the physical quantity is the result of an observation or measurement, this term is known as observable type or measurand.\nThe use of gml:quantityType for references to remote values is deprecated."],"quantityTypeReference (gml:)":["The gml:quantityTypeReference property indicates the phenomenon to which the units apply. The content is a reference to a remote value."],"roughConversionToPreferredUnit (gml:)":["The elements gml:conversionToPreferredUnit and gml:roughConversionToPreferredUnit represent parameters used to convert conventional units to preferred units for this physical quantity type.  A preferred unit is either a Base Unit or a Derived Unit that is selected for all values of one physical quantity type."],"unitOfMeasure (gml:)":["The element gml:unitOfMeasure is a property element to refer to a unit of measure. This is an empty element which carries a reference to a unit of measure definition."],"AbstractScalarValue (gml:)":["gml:AbstractScalarValue is an abstract element which acts as the head of a substitution group which contains gml:Boolean, gml:Category, gml:Count and gml:Quantity, and (transitively) the elements in their substitution groups."],"AbstractScalarValueList (gml:)":["gml:AbstractScalarValueList is an abstract element which acts as the head of a substitution group which contains gml:BooleanList, gml:CategoryList, gml:CountList and gml:QuantityList, and (transitively) the elements in their substitution groups."],"AbstractValue (gml:)":["gml:AbstractValue is an abstract element which acts as the head of a substitution group which contains gml:AbstractScalarValue, gml:AbstractScalarValueList, gml:CompositeValue and gml:ValueExtent, and (transitively) the elements in their substitution groups.\nThese elements may be used in an application schema as variables, so that in an XML instance document any member of its substitution group may occur."],"Category (gml:)":["A gml:Category has an optional XML attribute codeSpace, whose value is a URI which identifies a dictionary, codelist or authority for the term."],"CompositeValue (gml:)":["gml:CompositeValue is an aggregate value built from other values . It contains zero or an arbitrary number of gml:valueComponent elements, and zero or one gml:valueComponents property elements.  It may be used for strongly coupled aggregates (vectors, tensors) or for arbitrary collections of values."],"Quantity (gml:)":["An XML attribute uom (&#8220;unit of measure&#8221;) is required, whose value is a URI which identifies the definition of a ratio scale or units by which the numeric value shall be multiplied, or an interval or position scale on which the value occurs."],"ValueArray (gml:)":["A Value Array is used for homogeneous arrays of primitive and aggregate values.  \nThe member values may be scalars, composites, arrays or lists.\nValueArray has the same content model as CompositeValue, but the member values shall be homogeneous.  The element declaration contains a Schematron constraint which expresses this restriction precisely.  Since the members are homogeneous, the gml:referenceSystem (uom, codeSpace) may be specified on the gml:ValueArray itself and inherited by all the members if desired."],"valueComponent (gml:)":["Property that refers to, or contains, a Value."],"valueComponents (gml:)":["Property that contains Values."],"valueProperty (gml:)":["Property that refers to, or contains, a Value. Convenience element for general use."]},"attribute":{"uom (gml:)":["The uom attribute provides an identifier of the unit of measure used for this coordinate system axis. The value of this coordinate in a coordinate tuple shall be recorded using this unit of measure, whenever those coordinates use a coordinate reference system that uses a coordinate system that uses this axis."],"dynamicProperties (gml:)":["A convenience group. This allows an application schema developer to include dynamic properties in a content model in a standard fashion."],"SRSInformationGroup (gml:)":["The attributes uomLabels and axisLabels, defined in the SRSInformationGroup attribute group, are optional additional and redundant information for a CRS to simplify the processing of the coordinate values when a more complete definition of the CRS is not needed. This information shall be the same as included in the complete definition of the CRS, referenced by the srsName attribute. When the srsName attribute is included, either both or neither of the axisLabels and uomLabels attributes shall be included. When the srsName attribute is omitted, both of these attributes shall be omitted.\nThe attribute axisLabels is an ordered list of labels for all the axes of this CRS. The gml:axisAbbrev value should be used for these axis labels, after spaces and forbidden characters are removed. When the srsName attribute is included, this attribute is optional. When the srsName attribute is omitted, this attribute shall also be omitted.\nThe attribute uomLabels is an ordered list of unit of measure (uom) labels for all the axes of this CRS. The value of the string in the gml:catalogSymbol should be used for this uom labels, after spaces and forbidden characters are removed. When the axisLabels attribute is included, this attribute shall also be included. When the axisLabels attribute is omitted, this attribute shall also be omitted."],"SRSReferenceGroup (gml:)":["The attribute group SRSReferenceGroup is an optional reference to the CRS used by this geometry, with optional additional information to simplify the processing of the coordinates when a more complete definition of the CRS is not needed.\nIn general the attribute srsName points to a CRS instance of gml:AbstractCoordinateReferenceSystem. For well-known references it is not required that the CRS description exists at the location the URI points to. \nIf no srsName attribute is given, the CRS shall be specified as part of the larger context this geometry element is part of."],"geometricPositionGroup (gml:)":["GML supports two different ways to specify a geometric position: either by a direct position (a data type) or a point (a geometric object).\npos elements are positions that are &#8220;owned&#8221; by the geometric primitive encapsulating this geometric position.\npointProperty elements contain a point that may be referenced from other geometry elements or reference another point defined elsewhere (reuse of existing points)."],"geometricPositionListGroup (gml:)":["GML supports two different ways to specify a list of geometric positions: either by a sequence of geometric positions (by reusing the group definition) or a sequence of direct positions (element posList). \nThe posList element allows for a compact way to specify the coordinates of the positions, if all positions are represented in the same coordinate reference system."],"PointGrid (gml:)":["A gml:PointGrid group contains or references points or positions which are organised into sequences or grids. All rows shall have the same number of positions (columns)."],"id (gml:)":["The attribute gml:id supports provision of a handle for the XML element representing a GML Object. Its use is mandatory for all GML objects. It is of XML type ID, so is constrained to be unique in the XML document within which it occurs."],"AggregationAttributeGroup (gml:)":["A GML Object Collection is any GML Object with a property element in its content model whose content model is derived by extension from gml:AbstractMemberType.\nIn addition, the complex type describing the content model of the GML Object Collection may also include a reference to the attribute group gml:AggregationAttributeGroup to provide additional information about the semantics of the object collection.  This information may be used by applications to group GML objects, and optionally to order and index them.\nThe allowed values for the aggregationType attribute are defined by gml:AggregationType. See 8.4 of ISO\/IEC 11404:1996 for the meaning of the values in the enumeration."],"AssociationAttributeGroup (gml:)":["XLink components are the standard method to support hypertext referencing in XML. An XML Schema attribute group, gml:AssociationAttributeGroup, is provided to support the use of Xlinks as the method for indicating the value of a property by reference in a uniform manner in GML."],"OwnershipAttributeGroup (gml:)":["Encoding a GML property inline vs. by-reference shall not imply anything about the &#8220;ownership&#8221; of the contained or referenced GML Object, i.e. the encoding style shall not imply any &#8220;deep-copy&#8221; or &#8220;deep-delete&#8221; semantics. To express ownership over the contained or referenced GML Object, the gml:OwnershipAttributeGroup attribute group may be added to object-valued property elements. If the attribute group is not part of the content model of such a property element, then the value may not be &#8220;owned&#8221;.\nWhen the value of the owns attribute is \"true\", the existence of inline or referenced object(s) depends upon the existence of the parent object."],"timeLength (gml:)":["The length of a time period."],"Value (gml:)":["This is a convenience choice group which unifies generic values defined in this Clause with spatial and temporal objects and the measures described above, so that any of these may be used within aggregate values."],"actuate (xlink:)":["\n        The 'actuate' attribute is used to communicate the desired timing \n        of traversal from the starting resource to the ending resource; \n        it's value should be treated as follows:\n        onLoad - traverse to the ending resource immediately on loading \n                 the starting resource \n        onRequest - traverse from the starting resource to the ending \n                    resource only on a post-loading event triggered for \n                    this purpose \n        other - behavior is unconstrained; examine other markup in link \n                for hints \n        none - behavior is unconstrained\n      "],"show (xlink:)":["\n        The 'show' attribute is used to communicate the desired presentation \n        of the ending resource on traversal from the starting resource; it's \n        value should be treated as follows: \n        new - load ending resource in a new window, frame, pane, or other \n              presentation context\n        replace - load the resource in the same window, frame, pane, or \n                  other presentation context\n        embed - load ending resource in place of the presentation of the \n                starting resource\n        other - behavior is unconstrained; examine other markup in the \n                link for hints \n        none - behavior is unconstrained \n      "]}}}
